(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[    135711,       3010]
NotebookOptionsPosition[    129931,       2905]
NotebookOutlinePosition[    130470,       2924]
CellTagsIndexPosition[    130427,       2921]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Experiments on primitive root dynamics", "Title",
 CellChangeTimes->{{3.8729725742702274`*^9, 3.8729725998483353`*^9}, {
  3.872982067037202*^9, 3.872982071700882*^9}, {3.8750977066828113`*^9, 
  3.8750977094187794`*^9}, {3.8751006805624104`*^9, 3.87510069070317*^9}, {
  3.875100793420101*^9, 3.875100808861614*^9}, {3.8751046879873714`*^9, 
  3.875104694599913*^9}},ExpressionUUID->"49bd212c-b054-4509-97fc-\
aad19b77fc5b"],

Cell["Shenghui Yang, Wolfram Research", "Author",
 CellChangeTimes->{{3.8728561693882937`*^9, 
  3.8728561770538836`*^9}},ExpressionUUID->"e18fce9a-8b0a-4f30-8c0c-\
d34294660e35"],

Cell[CellGroupData[{

Cell["Study primitive root (Fermat\[CloseCurlyQuote]s little theorem)", \
"Section",
 CellChangeTimes->{
  3.872982091823163*^9, {3.8751002562131815`*^9, 
   3.8751002873708515`*^9}},ExpressionUUID->"77d044b2-4809-4c8e-8bc2-\
32fc6208deaa"],

Cell[CellGroupData[{

Cell["Fermat's little theorem", "WolframAlphaLong",
 CellChangeTimes->{{3.8751002957667537`*^9, 3.8751002978795037`*^9}},
 CellLabel->"In[27]:=",ExpressionUUID->"cb278679-901a-4090-821a-c7ad912ba87c"],

Cell[BoxData[
 NamespaceBox["WolframAlphaQueryResults",
  DynamicModuleBox[{Typeset`q$$ = "Fermat's little theorem", 
   Typeset`opts$$ = {
   AppearanceElements -> {
     "Warnings", "Assumptions", "Brand", "Pods", "PodMenus", "Unsuccessful", 
      "Sources"}, Asynchronous -> All, 
    TimeConstraint -> {20, Automatic, Automatic, Automatic}, 
    Method -> {
     "Formats" -> {"cell", "minput", "msound", "dataformats"}, "Server" -> 
      "https://api.wolframalpha.com/v1/"}, 
    PodStates -> {"HistoryPod:FamousMathProblem__More"}}, 
   Typeset`elements$$ = {
   "Warnings", "Assumptions", "Brand", "Pods", "PodMenus", "Unsuccessful", 
    "Sources"}, Typeset`pod1$$ = XMLElement[
   "pod", {"title" -> "Input interpretation", "scanner" -> "Identity", "id" -> 
     "Input", "position" -> "100", "error" -> "false", "numsubpods" -> "1"}, {
     XMLElement["subpod", {"title" -> ""}, {
       XMLElement[
       "minput", {}, {
        "Entity[\"FamousMathProblem\", \"FermatsLittleTheorem\"]"}], 
       XMLElement["cell", {"compressed" -> False, "string" -> True}, {
         Cell[
          BoxData[
           FormBox[
            TagBox[
             FormBox[
              StyleBox[
               TemplateBox[{
                 TagBox[
                  TagBox["\"Fermat's little theorem\"", 
                   $CellContext`TagBoxWrapper[
                   "Entity" -> {
                    "FamousMathProblem", "FermatsLittleTheorem"}]], Identity],
                  "\" \"", 
                 StyleBox[
                  
                  RowBox[{
                   "\"(\"", "\[NoBreak]", "\"mathematical problem\"", 
                    "\[NoBreak]", "\")\""}], {
                   GrayLevel[0.6], 
                   LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 
                   0}]}, "RowDefault"], LineIndent -> 0], TraditionalForm], 
             PolynomialForm[#, TraditionalOrder -> False]& ], 
            TraditionalForm]], "Output", {
          Background -> None, 
           GraphicsBoxOptions -> {
            DefaultBaseStyle -> {FontFamily -> "Times", "Graphics"}, 
             DefaultAxesStyle -> Directive[
               GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], FontOpacity -> 
               1, "GraphicsAxes"], DefaultFrameStyle -> Directive[
               GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], FontOpacity -> 
               1, "GraphicsFrame"], DefaultFrameTicksStyle -> 
             Directive[
              FontFamily -> "Times", FontSize -> 10, "GraphicsFrameTicks"], 
             DefaultTicksStyle -> 
             Directive[
              FontFamily -> "Times", FontSize -> 10, "GraphicsTicks"]}, 
           Graphics3DBoxOptions -> {
            DefaultBaseStyle -> {FontFamily -> "Times", "Graphics3D"}}}, 
          NumberPoint -> ".", CellSize -> {550, Automatic}, 
          AutoStyleOptions -> {"HighlightFormattingErrors" -> False}, 
          RenderingOptions -> {
           "3DRenderingMethod" -> "BSPTreeOrDepthBuffer"}]}], 
       XMLElement[
       "dataformats", {}, {
        "plaintext,minput,computabledata,formatteddata"}]}], 
     XMLElement["expressiontypes", {"count" -> "1"}, {"\n   ", 
       XMLElement["expressiontype", {"name" -> "Default"}, {}], "\n  "}]}], 
   Typeset`pod2$$ = XMLElement[
   "pod", {"title" -> "Statement", "scanner" -> "Data", "id" -> 
     "StatementPod:FamousMathProblem", "position" -> "200", "error" -> 
     "false", "numsubpods" -> "1"}, {
     XMLElement["subpod", {"title" -> ""}, {
       XMLElement["microsources", {}, {"\n    ", 
         XMLElement["microsource", {}, {"FamousMathProblem"}], "\n   "}], 
       XMLElement[
       "minput", {}, {
        "Entity[\"FamousMathProblem\", \
\"FermatsLittleTheorem\"][EntityProperty[\"FamousMathProblem\", \
\"Statement\"]]"}], 
       XMLElement["cell", {"compressed" -> False, "string" -> True}, {
         Cell[
          BoxData[
           FormBox[
            Cell[
             TextData[{"Fermat's little theorem states that for ", 
               Cell[
                BoxData[
                 FormBox[
                  FormBox[
                   TemplateBox[{
                    TagBox[
                    "p", PolynomialForm[#, TraditionalOrder -> False]& ]}, 
                    "RowDefault"], TraditionalForm], TraditionalForm]]], 
               " a prime and ", 
               Cell[
                BoxData[
                 FormBox[
                  FormBox[
                   TemplateBox[{
                    TagBox[
                    "a", PolynomialForm[#, TraditionalOrder -> False]& ]}, 
                    "RowDefault"], TraditionalForm], TraditionalForm]]], 
               " a positive integer not divisible by ", 
               Cell[
                BoxData[
                 FormBox[
                  TemplateBox[{
                    FormBox[
                    TemplateBox[{
                    TagBox[
                    "p", PolynomialForm[#, TraditionalOrder -> False]& ]}, 
                    "RowDefault"], TraditionalForm], "\", \""}, "RowDefault"],
                   TraditionalForm]]], 
               Cell[
                BoxData[
                 FormBox[
                  TemplateBox[{
                    FormBox[
                    TemplateBox[{
                    TagBox[
                    RowBox[{
                    RowBox[{
                    SuperscriptBox["a", 
                    
                    RowBox[{"p", "\[InvisibleSpace]", "-", 
                    "\[InvisibleSpace]", "1"}]], "\[InvisibleSpace]", "-", 
                    "\[InvisibleSpace]", "1"}], " ", "\[Congruent]", " ", "0",
                     " ", "(", "\[InvisibleSpace]", "mod ", 
                    "\[InvisibleSpace]", "p", "\[InvisibleSpace]", ")"}], 
                    PolynomialForm[#, TraditionalOrder -> False]& ]}, 
                    "RowDefault"], TraditionalForm], "\".\""}, "RowDefault"], 
                  TraditionalForm]]]}], TextJustification -> 0, Hyphenation -> 
             False, HyphenationOptions -> {
              "HyphenationCharacter" -> "\[Hyphen]", "HyphenationFreeZone" -> 
               0, "HyphenationMinLengths" -> {2, 2}}], TraditionalForm]], 
          "Output", {
          Background -> None, 
           GraphicsBoxOptions -> {
            DefaultBaseStyle -> {FontFamily -> "Times", "Graphics"}, 
             DefaultAxesStyle -> Directive[
               GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], FontOpacity -> 
               1, "GraphicsAxes"], DefaultFrameStyle -> Directive[
               GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], FontOpacity -> 
               1, "GraphicsFrame"], DefaultFrameTicksStyle -> 
             Directive[
              FontFamily -> "Times", FontSize -> 10, "GraphicsFrameTicks"], 
             DefaultTicksStyle -> 
             Directive[
              FontFamily -> "Times", FontSize -> 10, "GraphicsTicks"]}, 
           Graphics3DBoxOptions -> {
            DefaultBaseStyle -> {FontFamily -> "Times", "Graphics3D"}}}, 
          NumberPoint -> ".", CellSize -> {550, Automatic}, 
          AutoStyleOptions -> {"HighlightFormattingErrors" -> False}, 
          RenderingOptions -> {
           "3DRenderingMethod" -> "BSPTreeOrDepthBuffer"}]}], 
       XMLElement[
       "dataformats", {}, {
        "plaintext,minput,computabledata,formatteddata"}]}], 
     XMLElement["expressiontypes", {"count" -> "1"}, {"\n   ", 
       XMLElement["expressiontype", {"name" -> "Default"}, {}], "\n  "}]}], 
   Typeset`pod3$$ = XMLElement[
   "pod", {"title" -> "Formal statement", "scanner" -> "Data", "id" -> 
     "FormalStatementPod:FamousMathProblem", "position" -> "300", "error" -> 
     "false", "numsubpods" -> "1"}, {
     XMLElement["subpod", {"title" -> ""}, {
       XMLElement["microsources", {}, {"\n    ", 
         XMLElement["microsource", {}, {"FamousMathProblem"}], "\n   "}], 
       XMLElement[
       "minput", {}, {
        "Entity[\"FamousMathProblem\", \
\"FermatsLittleTheorem\"][EntityProperty[\"FamousMathProblem\", \
\"FormalStatement\"]]"}], 
       XMLElement["cell", {"compressed" -> False, "string" -> True}, {
         Cell[
          BoxData[
           FormBox[
            FormBox[
             TemplateBox[{
               TagBox[
                RowBox[{
                  SubscriptBox["\[ForAll]", 
                   RowBox[{
                    RowBox[{"{", "\[InvisibleSpace]", 
                    
                    RowBox[{
                    "p", "\[InvisibleSpace]", ",", "\[InvisibleSpace]", "a"}],
                     "\[InvisibleSpace]", "}"}], "\[InvisibleSpace]", ",", 
                    "\[InvisibleSpace]", 
                    RowBox[{
                    
                    RowBox[{
                    "p", "\[InvisibleSpace]", "\[Element]", 
                    "\[InvisibleSpace]", 
                    StyleBox[
                    "\[DoubleStruckCapitalP]", ShowSyntaxStyles -> False, 
                    FontFamily -> "Times"]}], "\[InvisibleSpace]", "\[And]", 
                    "\[InvisibleSpace]", 
                    
                    RowBox[{
                    "a", "\[InvisibleSpace]", "\[Element]", 
                    "\[InvisibleSpace]", 
                    SuperscriptBox["\[DoubleStruckCapitalZ]", "+"]}], 
                    "\[InvisibleSpace]", "\[And]", "\[InvisibleSpace]", 
                    RowBox[{
                    RowBox[{"a", " ", "mod", " ", "p"}], "\[InvisibleSpace]", 
                    "\[NotEqual]", "\[InvisibleSpace]", "0"}]}]}]], 
                  "\[InvisibleSpace]", 
                  RowBox[{
                    RowBox[{
                    RowBox[{"(", "\[InvisibleSpace]", 
                    RowBox[{
                    SuperscriptBox["a", 
                    
                    RowBox[{
                    "p", "\[InvisibleSpace]", "-", "\[InvisibleSpace]", 
                    "1"}]], "\[InvisibleSpace]", "-", "\[InvisibleSpace]", 
                    "1"}], "\[InvisibleSpace]", ")"}], " ", "mod", " ", "p"}],
                     "\[LongEqual]", "0"}]}], 
                PolynomialForm[#, TraditionalOrder -> False]& ]}, 
              "RowDefault"], TraditionalForm], TraditionalForm]], "Output", {
          Background -> None, 
           GraphicsBoxOptions -> {
            DefaultBaseStyle -> {FontFamily -> "Times", "Graphics"}, 
             DefaultAxesStyle -> Directive[
               GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], FontOpacity -> 
               1, "GraphicsAxes"], DefaultFrameStyle -> Directive[
               GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], FontOpacity -> 
               1, "GraphicsFrame"], DefaultFrameTicksStyle -> 
             Directive[
              FontFamily -> "Times", FontSize -> 10, "GraphicsFrameTicks"], 
             DefaultTicksStyle -> 
             Directive[
              FontFamily -> "Times", FontSize -> 10, "GraphicsTicks"]}, 
           Graphics3DBoxOptions -> {
            DefaultBaseStyle -> {FontFamily -> "Times", "Graphics3D"}}}, 
          NumberPoint -> ".", CellSize -> {550, Automatic}, 
          AutoStyleOptions -> {"HighlightFormattingErrors" -> False}, 
          RenderingOptions -> {
           "3DRenderingMethod" -> "BSPTreeOrDepthBuffer"}]}], 
       XMLElement[
       "dataformats", {}, {
        "plaintext,minput,computabledata,formatteddata"}]}], 
     XMLElement["expressiontypes", {"count" -> "1"}, {"\n   ", 
       XMLElement["expressiontype", {"name" -> "Grid"}, {}], "\n  "}], 
     XMLElement["infos", {"count" -> "4"}, {
       XMLElement[
       "info", {
        "text" -> "e_1 \[And] e_2 \[And] ... is the logical AND function"}, {
         XMLElement[
         "link", {
          "url" -> "http://reference.wolfram.com/language/ref/And.html", 
           "text" -> "Documentation", "title" -> "Mathematica"}, {}], 
         XMLElement[
         "link", {
          "url" -> "http://mathworld.wolfram.com/AND.html", "text" -> 
           "Definition", "title" -> "MathWorld"}, {}]}], 
       XMLElement[
       "info", {
        "text" -> 
         "for all _x expr represents the statement that expr is True for all \
values of x"}, {
         XMLElement[
         "link", {
          "url" -> "http://reference.wolfram.com/language/ref/ForAll.html", 
           "text" -> "Documentation", "title" -> "Mathematica"}, {}], 
         XMLElement[
         "link", {
          "url" -> "http://mathworld.wolfram.com/ForAll.html", "text" -> 
           "Definition", "title" -> "MathWorld"}, {}]}], 
       XMLElement["info", {"text" -> "P is the set of prime numbers"}, {
         XMLElement[
         "link", {
          "url" -> "http://reference.wolfram.com/language/ref/Primes.html", 
           "text" -> "Documentation", "title" -> "Documentation"}, {}], 
         XMLElement[
         "link", {
          "url" -> "http://mathworld.wolfram.com/Primes.html", "text" -> 
           "Definition", "title" -> "MathWorld"}, {}]}], 
       XMLElement[
       "info", {"text" -> "Z_(> 0) is the set of positive integers"}, {
         XMLElement[
         "link", {
          "url" -> 
           "http://reference.wolfram.com/language/ref/PositiveIntegers.html", 
           "text" -> "Documentation", "title" -> "Documentation"}, {}], 
         XMLElement[
         "link", {
          "url" -> "http://mathworld.wolfram.com/PositiveInteger.html", 
           "text" -> "Definition", "title" -> "MathWorld"}, {}]}]}]}], 
   Typeset`pod4$$ = XMLElement[
   "pod", {"title" -> "History", "scanner" -> "Data", "id" -> 
     "HistoryPod:FamousMathProblem", "position" -> "100", "error" -> "false", 
     "numsubpods" -> "1"}, {
     XMLElement["subpod", {"title" -> ""}, {
       XMLElement["microsources", {}, {"\n    ", 
         XMLElement["microsource", {}, {"FamousMathProblem"}], "\n   "}], 
       XMLElement[
       "minput", {}, {
        "Dataset[EntityValue[Entity[\"FamousMathProblem\", \
\"FermatsLittleTheorem\"], {EntityProperty[\"FamousMathProblem\", \
\"FormulationDate\"], EntityProperty[\"FamousMathProblem\", \"Formulators\"], \
EntityProperty[\"FamousMathProblem\", \"FormulationSource\"], EntityProperty[\
\"FamousMathProblem\", \"Status\"], EntityProperty[\"FamousMathProblem\", \
\"ProofDate\"], EntityProperty[\"FamousMathProblem\", \"Provers\"], \
EntityProperty[\"FamousMathProblem\", \"ProofSource\"]}, \
\"PropertyAssociation\"]]"}], 
       XMLElement["cell", {"compressed" -> True, "string" -> False}, {
         Cell[
          BoxData[
           FormBox[
            StyleBox[
             TagBox[
              GridBox[{{
                 TagBox[
                  PaneBox[
                   TagBox["\"formulation date\"", Identity], 
                   BaseStyle -> {{
                    BaselinePosition -> Baseline, FontColor -> 
                    GrayLevel[0.3]}, LineSpacing -> {0.9, 0, 1.5}, 
                    LinebreakAdjustments -> {1, 10, 10000, 0, 100}, 
                    TextAlignment -> Left}, BaselinePosition -> Baseline], 
                  $CellContext`TagBoxWrapper["Label"]], 
                 StyleBox[
                  TemplateBox[{
                    FormBox[
                    TagBox["\"1640\"", Identity], TraditionalForm], "\"  \"", 
                    StyleBox[
                    RowBox[{"\"(\"", "\[NoBreak]", 
                    TemplateBox[{
                    StyleBox[
                    TagBox[
                    TagBox[
                    TagBox[
                    RowBox[{
                    TagBox["382", #& ], "\[InvisibleSpace]", " ", 
                    StyleBox[
                    "\"years\"", {
                    FontFamily -> "Roboto", FontSize -> Smaller, 
                    LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 
                    0}]}], Identity], #& , SyntaxForm -> Dot], "Unit", 
                    SyntaxForm -> Dot], 
                    LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 
                    0, ZeroWidthTimes -> False], "\" ago\""}, "RowDefault"], 
                    "\[NoBreak]", "\")\""}], {
                    FontFamily -> "Roboto", FontSize -> 10, 
                    GrayLevel[0.5], 
                    LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 
                    0}]}, "RowDefault"], LineIndent -> 0]}, {
                 TagBox[
                  PaneBox[
                   TagBox["\"formulator\"", Identity], 
                   BaseStyle -> {{
                    BaselinePosition -> Baseline, FontColor -> 
                    GrayLevel[0.3]}, LineSpacing -> {0.9, 0, 1.5}, 
                    LinebreakAdjustments -> {1, 10, 10000, 0, 100}, 
                    TextAlignment -> Left}, BaselinePosition -> Baseline], 
                  $CellContext`TagBoxWrapper["Label"]], 
                 FormBox[
                  TagBox[
                   TagBox["\"Pierre de Fermat\"", 
                    $CellContext`TagBoxWrapper[
                    "Entity" -> {$CellContext`PeopleData, 
                    "PierreDeFermat::p9q8b"}]], Identity], TraditionalForm]}, {
                 TagBox[
                  PaneBox[
                   TagBox["\"formulation source\"", Identity], 
                   BaseStyle -> {{
                    BaselinePosition -> Baseline, FontColor -> 
                    GrayLevel[0.3]}, LineSpacing -> {0.9, 0, 1.5}, 
                    LinebreakAdjustments -> {1, 10, 10000, 0, 100}, 
                    TextAlignment -> Left}, BaselinePosition -> Baseline], 
                  $CellContext`TagBoxWrapper["Label"]], 
                 InterpretationBox[
                  Cell[
                  "de Fermat, P.  Letter to F. de Bessy.  Oct. 18, 1640.", 
                   TextJustification -> 0, 
                   HyphenationOptions -> {
                    "HyphenationCharacter" -> "\[Hyphen]", 
                    "HyphenationFreeZone" -> 0, 
                    "HyphenationMinLengths" -> {2, 2}}], 
                  TextCell[
                  "de Fermat, P.  Letter to F. de Bessy.  Oct. 18, 1640.", 
                   TextJustification -> 0, 
                   HyphenationOptions -> {
                    "HyphenationCharacter" -> "\[Hyphen]", 
                    "HyphenationFreeZone" -> 0, 
                    "HyphenationMinLengths" -> {2, 2}}]]}, {
                 TagBox[
                  PaneBox[
                   TagBox["\"status\"", Identity], 
                   BaseStyle -> {{
                    BaselinePosition -> Baseline, FontColor -> 
                    GrayLevel[0.3]}, LineSpacing -> {0.9, 0, 1.5}, 
                    LinebreakAdjustments -> {1, 10, 10000, 0, 100}, 
                    TextAlignment -> Left}, BaselinePosition -> Baseline], 
                  $CellContext`TagBoxWrapper["Label"]], 
                 StyleBox[
                 "\"proved\"", {
                  LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 
                   0}]}, {
                 TagBox[
                  PaneBox[
                   TagBox["\"proof date\"", Identity], 
                   BaseStyle -> {{
                    BaselinePosition -> Baseline, FontColor -> 
                    GrayLevel[0.3]}, LineSpacing -> {0.9, 0, 1.5}, 
                    LinebreakAdjustments -> {1, 10, 10000, 0, 100}, 
                    TextAlignment -> Left}, BaselinePosition -> Baseline], 
                  $CellContext`TagBoxWrapper["Label"]], 
                 StyleBox[
                  TemplateBox[{
                    FormBox[
                    TagBox["\"1736\"", Identity], TraditionalForm], "\" \"", 
                    StyleBox[
                    TemplateBox[{
                    StyleBox[
                    
                    RowBox[{
                    "\"(\"", "\[NoBreak]", "\"96 years later\"", "\[NoBreak]",
                     "\")\""}], {FontFamily -> "Roboto", FontSize -> 10, 
                    GrayLevel[0.5], 
                    LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 
                    0}], "\"  \"", 
                    StyleBox[
                    
                    RowBox[{
                    "\"(\"", "\[NoBreak]", "\"286 years ago\"", "\[NoBreak]", 
                    "\")\""}], {FontFamily -> "Roboto", FontSize -> 10, 
                    GrayLevel[0.5], 
                    LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 
                    0}]}, "RowDefault"], {
                    LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 
                    0}]}, "RowDefault"], LineIndent -> 0]}, {
                 TagBox[
                  PaneBox[
                   TagBox["\"provers\"", Identity], 
                   BaseStyle -> {{
                    BaselinePosition -> Baseline, FontColor -> 
                    GrayLevel[0.3]}, LineSpacing -> {0.9, 0, 1.5}, 
                    LinebreakAdjustments -> {1, 10, 10000, 0, 100}, 
                    TextAlignment -> Left}, BaselinePosition -> Baseline], 
                  $CellContext`TagBoxWrapper["Label"]], 
                 StyleBox[
                  RowBox[{
                    FormBox[
                    TagBox[
                    TagBox["\"Pierre de Fermat\"", 
                    $CellContext`TagBoxWrapper[
                    "Entity" -> {$CellContext`PeopleData, 
                    "PierreDeFermat::p9q8b"}]], Identity], TraditionalForm], 
                    StyleBox[
                    RowBox[{"\[NoBreak]", 
                    PaneBox[
                    "\"  |  \"", BaselinePosition -> Baseline, BaseStyle -> 
                    GrayLevel[0.6]]}], AutoSpacing -> True], 
                    FormBox[
                    TagBox[
                    TagBox["\"Gottfried Leibniz\"", 
                    $CellContext`TagBoxWrapper[
                    "Entity" -> {$CellContext`PeopleData, 
                    "GottfriedLeibniz::s2hc2"}]], Identity], TraditionalForm], 
                    StyleBox[
                    RowBox[{"\[NoBreak]", 
                    PaneBox[
                    "\"  |  \"", BaselinePosition -> Baseline, BaseStyle -> 
                    GrayLevel[0.6]]}], AutoSpacing -> True], 
                    FormBox[
                    TagBox[
                    TagBox["\"Leonhard Euler\"", 
                    $CellContext`TagBoxWrapper[
                    "Entity" -> {$CellContext`PeopleData, 
                    "LeonhardEuler::39r8r"}]], Identity], TraditionalForm]}], 
                  LinebreakAdjustments -> {1, 10, 0, 0, 100}, LineIndent -> 
                  0]}, {
                 TagBox[
                  PaneBox[
                   TagBox["\"proof sources\"", Identity], 
                   BaseStyle -> {{
                    BaselinePosition -> Baseline, FontColor -> 
                    GrayLevel[0.3]}, LineSpacing -> {0.9, 0, 1.5}, 
                    LinebreakAdjustments -> {1, 10, 10000, 0, 100}, 
                    TextAlignment -> Left}, BaselinePosition -> Baseline], 
                  $CellContext`TagBoxWrapper["Label"]], 
                 StyleBox[
                 "\"Presumably proved but suppressed by Fermat around \
1640.\"", {
                   GrayLevel[0.6], 
                   LinebreakAdjustments -> {1, 100, 1, 0, 100}, LineIndent -> 
                   0}]}, {"\[SpanFromAbove]", 
                 InterpretationBox[
                  Cell[
                  "Leibniz, G.  Unpublished manuscript prior to 1683.", 
                   TextJustification -> 0, 
                   HyphenationOptions -> {
                    "HyphenationCharacter" -> "\[Hyphen]", 
                    "HyphenationFreeZone" -> 0, 
                    "HyphenationMinLengths" -> {2, 2}}], 
                  TextCell[
                  "Leibniz, G.  Unpublished manuscript prior to 1683.", 
                   TextJustification -> 0, 
                   HyphenationOptions -> {
                    "HyphenationCharacter" -> "\[Hyphen]", 
                    "HyphenationFreeZone" -> 0, 
                    "HyphenationMinLengths" -> {2, 2}}]]}, {
                "\[SpanFromAbove]", 
                 Cell[
                  
                  TextData[{
                   "Euler, L.  \[OpenCurlyDoubleQuote]Theorematum Quorundam \
ad Numeros Primos Spectantium Demonstratio.\[CloseCurlyDoubleQuote]  ", 
                    Cell[
                    BoxData[
                    FormBox[
                    StyleBox[
                    "\"Commentarii academiae scientiarum Petropolitanae\"", 
                    Italic, StripOnInput -> False], TraditionalForm]]], " ", 
                    Cell[
                    BoxData[
                    FormBox[
                    TemplateBox[{
                    StyleBox["\"8\"", Bold, StripOnInput -> False], "\", \""},
                     "RowDefault"], TraditionalForm]]], 
                    "141\[Dash]146, 1736 (1741)."}], TextJustification -> 0, 
                  Hyphenation -> False, 
                  HyphenationOptions -> {
                   "HyphenationCharacter" -> "\[Hyphen]", 
                    "HyphenationFreeZone" -> 0, 
                    "HyphenationMinLengths" -> {2, 2}}]}}, 
               GridBoxAlignment -> {
                "Columns" -> {Left, Left}, "Rows" -> {{Baseline}}}, 
               AutoDelete -> False, 
               GridBoxBackground -> {"Columns" -> {None, None}}, 
               GridBoxFrame -> {"Columns" -> {{True}}, "Rows" -> {{True}}}, 
               GridBoxItemSize -> {
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}, 
               GridBoxSpacings -> {"Columns" -> {{1.5}, 2}, "Rows" -> {{1}}}, 
               FrameStyle -> GrayLevel[0.84], BaselinePosition -> Automatic, 
               AllowScriptLevelChange -> False], "Grid"], 
             LineSpacing -> {0.9, 0, 1.5}, LineIndent -> 0, StripOnInput -> 
             False], TraditionalForm]], "Output", {
          Background -> None, 
           GraphicsBoxOptions -> {
            DefaultBaseStyle -> {FontFamily -> "Times", "Graphics"}, 
             DefaultAxesStyle -> Directive[
               GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], FontOpacity -> 
               1, "GraphicsAxes"], DefaultFrameStyle -> Directive[
               GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], FontOpacity -> 
               1, "GraphicsFrame"], DefaultFrameTicksStyle -> 
             Directive[
              FontFamily -> "Times", FontSize -> 10, "GraphicsFrameTicks"], 
             DefaultTicksStyle -> 
             Directive[
              FontFamily -> "Times", FontSize -> 10, "GraphicsTicks"]}, 
           Graphics3DBoxOptions -> {
            DefaultBaseStyle -> {FontFamily -> "Times", "Graphics3D"}}}, 
          NumberPoint -> ".", CellSize -> {550, Automatic}, 
          AutoStyleOptions -> {"HighlightFormattingErrors" -> False}, 
          RenderingOptions -> {
           "3DRenderingMethod" -> "BSPTreeOrDepthBuffer"}]}], 
       XMLElement[
       "dataformats", {}, {
        "plaintext,minput,computabledata,formatteddata"}]}], 
     XMLElement["expressiontypes", {"count" -> "1"}, {"\n   ", 
       XMLElement["expressiontype", {"name" -> "Grid"}, {}], "\n  "}], 
     XMLElement["states", {"count" -> "1"}, {
       XMLElement[
       "state", {
        "name" -> "Less", "input" -> 
         "HistoryPod:FamousMathProblem__Less"}, {}]}]}], Typeset`pod5$$ = 
   XMLElement[
   "pod", {"title" -> "Associated equation", "scanner" -> "Data", "id" -> 
     "FormulasPod:FamousMathProblem", "position" -> "500", "error" -> "false",
      "numsubpods" -> "1"}, {
     XMLElement["subpod", {"title" -> ""}, {
       XMLElement["microsources", {}, {"\n    ", 
         XMLElement["microsource", {}, {"FamousMathProblem"}], "\n   "}], 
       XMLElement[
       "minput", {}, {
        "Entity[\"FamousMathProblem\", \
\"FermatsLittleTheorem\"][EntityProperty[\"FamousMathProblem\", \
\"AssociatedEquations\"]]"}], 
       XMLElement["cell", {"compressed" -> False, "string" -> True}, {
         Cell[
          BoxData[
           FormBox[
            FormBox[
             TemplateBox[{
               TagBox[
                RowBox[{
                  RowBox[{
                    RowBox[{"(", "\[InvisibleSpace]", 
                    RowBox[{
                    SuperscriptBox["a", 
                    
                    RowBox[{
                    "p", "\[InvisibleSpace]", "-", "\[InvisibleSpace]", 
                    "1"}]], "\[InvisibleSpace]", "-", "\[InvisibleSpace]", 
                    "1"}], "\[InvisibleSpace]", ")"}], " ", "mod", " ", "p"}],
                   "\[LongEqual]", "0"}], 
                PolynomialForm[#, TraditionalOrder -> False]& ]}, 
              "RowDefault"], TraditionalForm], TraditionalForm]], "Output", {
          Background -> None, 
           GraphicsBoxOptions -> {
            DefaultBaseStyle -> {FontFamily -> "Times", "Graphics"}, 
             DefaultAxesStyle -> Directive[
               GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], FontOpacity -> 
               1, "GraphicsAxes"], DefaultFrameStyle -> Directive[
               GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], FontOpacity -> 
               1, "GraphicsFrame"], DefaultFrameTicksStyle -> 
             Directive[
              FontFamily -> "Times", FontSize -> 10, "GraphicsFrameTicks"], 
             DefaultTicksStyle -> 
             Directive[
              FontFamily -> "Times", FontSize -> 10, "GraphicsTicks"]}, 
           Graphics3DBoxOptions -> {
            DefaultBaseStyle -> {FontFamily -> "Times", "Graphics3D"}}}, 
          NumberPoint -> ".", CellSize -> {550, Automatic}, 
          AutoStyleOptions -> {"HighlightFormattingErrors" -> False}, 
          RenderingOptions -> {
           "3DRenderingMethod" -> "BSPTreeOrDepthBuffer"}]}], 
       XMLElement[
       "dataformats", {}, {
        "plaintext,minput,computabledata,formatteddata,formuladata"}]}], 
     XMLElement["expressiontypes", {"count" -> "1"}, {"\n   ", 
       XMLElement["expressiontype", {"name" -> "Grid"}, {}], "\n  "}]}], 
   Typeset`pod6$$ = XMLElement[
   "pod", {"title" -> "Classes", "scanner" -> "Data", "id" -> 
     "PropertiesPod:FamousMathProblem", "position" -> "600", "error" -> 
     "false", "numsubpods" -> "1"}, {
     XMLElement["subpod", {"title" -> ""}, {
       XMLElement["microsources", {}, {"\n    ", 
         XMLElement["microsource", {}, {"FamousMathProblem"}], "\n   "}], 
       XMLElement[
       "minput", {}, {
        "Entity[\"FamousMathProblem\", \
\"FermatsLittleTheorem\"][EntityProperty[\"FamousMathProblem\", \
\"Classes\"]]"}], 
       XMLElement["cell", {"compressed" -> False, "string" -> True}, {
         Cell[
          BoxData[
           FormBox[
            StyleBox[
             RowBox[{
               TagBox[
                TagBox["\"solved mathematics problems\"", 
                 $CellContext`TagBoxWrapper[
                 "EntityClass" -> {"FamousMathProblem", "Solved"}]], 
                Identity], 
               StyleBox[
                RowBox[{"\[NoBreak]", 
                  PaneBox[
                  "\"  |  \"", BaselinePosition -> Baseline, BaseStyle -> 
                   GrayLevel[0.6]]}], AutoSpacing -> True], 
               TagBox[
                TagBox["\"mathematics theorems\"", 
                 $CellContext`TagBoxWrapper[
                 "EntityClass" -> {"FamousMathProblem", "Theorem"}]], 
                Identity]}], LinebreakAdjustments -> {1, 10, 0, 0, 100}, 
             LineIndent -> 0], TraditionalForm]], "Output", {
          Background -> None, 
           GraphicsBoxOptions -> {
            DefaultBaseStyle -> {FontFamily -> "Times", "Graphics"}, 
             DefaultAxesStyle -> Directive[
               GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], FontOpacity -> 
               1, "GraphicsAxes"], DefaultFrameStyle -> Directive[
               GrayLevel[0, 0.35], FontColor -> GrayLevel[0.25], FontOpacity -> 
               1, "GraphicsFrame"], DefaultFrameTicksStyle -> 
             Directive[
              FontFamily -> "Times", FontSize -> 10, "GraphicsFrameTicks"], 
             DefaultTicksStyle -> 
             Directive[
              FontFamily -> "Times", FontSize -> 10, "GraphicsTicks"]}, 
           Graphics3DBoxOptions -> {
            DefaultBaseStyle -> {FontFamily -> "Times", "Graphics3D"}}}, 
          NumberPoint -> ".", CellSize -> {550, Automatic}, 
          AutoStyleOptions -> {"HighlightFormattingErrors" -> False}, 
          RenderingOptions -> {
           "3DRenderingMethod" -> "BSPTreeOrDepthBuffer"}]}], 
       XMLElement[
       "dataformats", {}, {
        "plaintext,minput,computabledata,formatteddata"}]}], 
     XMLElement["expressiontypes", {"count" -> "1"}, {"\n   ", 
       XMLElement["expressiontype", {"name" -> "Default"}, {}], "\n  "}]}], 
   Typeset`aux1$$ = {True, False, {False}, True}, Typeset`aux2$$ = {
   True, False, {False}, True}, Typeset`aux3$$ = {True, False, {False}, True},
    Typeset`aux4$$ = {True, False, {False}, True}, Typeset`aux5$$ = {
   True, False, {False}, True}, Typeset`aux6$$ = {True, False, {False}, True},
    Typeset`asyncpods$$ = {}, Typeset`nonpods$$ = {
    XMLElement["sources", {"count" -> "1"}, {
      XMLElement[
      "source", {
       "url" -> 
        "https://www6b3.wolframalpha.com/sources/\
FamousMathProblemSourceInformationNotes.html", "text" -> 
        "Famous math problem"}, {}]}]}, Typeset`initdone$$ = 
   FrontEnd`SuppressEvaluationHash[True], Typeset`queryinfo$$ = {
   "success" -> "true", "error" -> 
    "false", {"http://www.w3.org/XML/1998/namespace", "space"} -> "preserve", 
    "numpods" -> "6", "datatypes" -> "FamousMathProblem", "timedout" -> "", 
    "timedoutpods" -> "", "timing" -> "0.673", "parsetiming" -> "0.156", 
    "parsetimedout" -> "false", "recalculate" -> "", "id" -> 
    "MSP186419cb62h9842d2i89000045hd4cde4b9353ca", "host" -> 
    "https://www6b3.wolframalpha.com", "server" -> "18", "related" -> 
    "https://www6b3.wolframalpha.com/api/v1/relatedQueries.jsp?id=\
MSPa186519cb62h9842d2i89000028i963i258cfb6681697175660060143921", "version" -> 
    "2.6", "inputstring" -> "Fermat's little theorem"}, 
   Typeset`sessioninfo$$ = {
   "TimeZone" -> -5., 
    "Date" -> {2022, 10, 18, 11, 45, 1.5832242`7.952117405987345}, "Line" -> 
    27, "SessionID" -> 30051376977511740721}, Typeset`showpods$$ = {1, 2, 3, 
   4, 5, 6}, Typeset`failedpods$$ = {}, Typeset`chosen$$ = {}, 
   Typeset`open$$ = False, Typeset`newq$$ = "Fermat's little theorem"}, 
   DynamicBox[ToBoxes[
     AlphaIntegration`FormatAlphaResults[
      Dynamic[{
       1, {Typeset`pod1$$, Typeset`pod2$$, Typeset`pod3$$, Typeset`pod4$$, 
         Typeset`pod5$$, Typeset`pod6$$}, {
        Typeset`aux1$$, Typeset`aux2$$, Typeset`aux3$$, Typeset`aux4$$, 
         Typeset`aux5$$, Typeset`aux6$$}, Typeset`chosen$$, Typeset`open$$, 
        Typeset`elements$$, Typeset`q$$, Typeset`opts$$, Typeset`nonpods$$, 
        Typeset`queryinfo$$, Typeset`sessioninfo$$, Typeset`showpods$$, 
        Typeset`failedpods$$, Typeset`newq$$}]], StandardForm],
    ImageSizeCache->{
     780.4000000000001, {400.2899415183812, 406.1100584816188}},
    TrackedSymbols:>{Typeset`showpods$$, Typeset`failedpods$$}],
   DynamicModuleValues:>{},
   Initialization:>If[
     And[
      Not[Typeset`initdone$$ === True], 
      Not[Typeset`initdone$$ === FrontEnd`SuppressEvaluationHash[True]]], 
     Null; WolframAlphaClient`Private`doAsyncUpdates[
       Hold[{
        Typeset`pod1$$, Typeset`pod2$$, Typeset`pod3$$, Typeset`pod4$$, 
         Typeset`pod5$$, Typeset`pod6$$}], Typeset`asyncpods$$, 
       Dynamic[Typeset`failedpods$$]]; Typeset`asyncpods$$ = {}; 
     Typeset`initdone$$ = FrontEnd`SuppressEvaluationHash[True]],
   SynchronousInitialization->False],
  BaseStyle->{Deployed -> True},
  DeleteWithContents->True,
  Editable->False,
  SelectWithContents->True]], "Print", "WolframAlphaFullOutput",
 CellChangeTimes->{
  3.8751003016279554`*^9},ExpressionUUID->"fed659c7-2a24-4d35-b41e-\
aa559324c056"]
}, Open  ]],

Cell[TextData[{
 "For instance 3 is a primitive root of 31 because there is not number ",
 Cell[BoxData[
  FormBox["k", TraditionalForm]],
  FormatType->TraditionalForm,ExpressionUUID->
  "6ed053e9-bd9f-4256-8d04-c7855234e0ac"],
 " less than 30 such that ",
 Cell[BoxData[
  FormBox[Cell[TextData[Cell[BoxData[
    FormBox[
     RowBox[{
      SuperscriptBox["3", "k"], "=", " ", 
      RowBox[{"1", " ", 
       RowBox[{"(", 
        RowBox[{"mod", " ", "31"}], ")"}]}]}], TraditionalForm]],
    FormatType->TraditionalForm,ExpressionUUID->
    "8c9bf91b-f1aa-4140-9c3a-efdd0ff928d1"]],ExpressionUUID->
    "30c2870b-514a-4e01-afad-ed7336afcaf5"], TraditionalForm]],
  FormatType->TraditionalForm,ExpressionUUID->
  "bfaa56f2-44ef-4d90-b15e-d37ab8cfd555"],
 ":"
}], "Text",
 CellChangeTimes->{{3.8751000965391407`*^9, 3.87510009944811*^9}, {
  3.875100244506522*^9, 3.8751002763078084`*^9}, {3.8751003234909077`*^9, 
  3.875100376252817*^9}, {3.8751005067830544`*^9, 
  3.8751005168012333`*^9}},ExpressionUUID->"962868e8-c2fb-45e6-816e-\
641782682ade"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mod", "=", 
  RowBox[{"Array", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"PowerMod", "[", 
      RowBox[{"3", ",", "#", ",", "31"}], "]"}], "&"}], ",", "30"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.872969153164588*^9, 3.8729692233212147`*^9}, {
  3.8729692931918755`*^9, 3.872969295568161*^9}, {3.8729693466502414`*^9, 
  3.87296936256791*^9}},
 CellLabel->"In[35]:=",ExpressionUUID->"5a671e7d-1789-42de-baa1-7090d2a87b10"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "3", ",", "9", ",", "27", ",", "19", ",", "26", ",", "16", ",", "17", ",", 
   "20", ",", "29", ",", "25", ",", "13", ",", "8", ",", "24", ",", "10", ",",
    "30", ",", "28", ",", "22", ",", "4", ",", "12", ",", "5", ",", "15", ",",
    "14", ",", "11", ",", "2", ",", "6", ",", "18", ",", "23", ",", "7", ",", 
   "21", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{{3.872969199079039*^9, 3.8729692237738276`*^9}, 
   3.8729692960714774`*^9, {3.8729693542098184`*^9, 3.8729693631344337`*^9}, 
   3.873327352458463*^9, 3.8748479689442377`*^9, 3.874848046430151*^9, 
   3.874949682247779*^9, 3.875101670481499*^9},
 CellLabel->"Out[35]=",ExpressionUUID->"0c369cf3-ea32-4546-889f-79659d3e2412"]
}, Open  ]],

Cell["This is also verified by: ", "Text",
 CellChangeTimes->{{3.8751006348263865`*^9, 3.8751006438129396`*^9}, {
  3.8751007777237043`*^9, 
  3.8751007826965914`*^9}},ExpressionUUID->"291e8784-d271-4796-b158-\
2cec15e679c6"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PrimitiveRoot", "[", "31", "]"}]], "Input",
 CellChangeTimes->{{3.8751031180324173`*^9, 3.8751031235586023`*^9}},
 CellLabel->"In[47]:=",ExpressionUUID->"6c50c435-2981-45ab-82d0-dbf7d4cdab50"],

Cell[BoxData["3"], "Output",
 CellChangeTimes->{{3.875103118367057*^9, 3.8751031239518013`*^9}},
 CellLabel->"Out[47]=",ExpressionUUID->"0b97cddf-cf7e-4409-8dbc-b81f4faa01a5"]
}, Open  ]],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"PrimitiveRootList", "[", "31", "]"}]], "Input",
 CellChangeTimes->{{3.8751005835579724`*^9, 3.8751005988249793`*^9}, {
  3.875103033632264*^9, 3.8751030340340815`*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"b62dc8b1-5e37-475f-b08f-4e5b7ab5ac2a"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "3", ",", "11", ",", "12", ",", "13", ",", "17", ",", "21", ",", "22", ",", 
   "24"}], "}"}]], "Output",
 CellChangeTimes->{3.875100599402362*^9, 3.875103034886634*^9},
 CellLabel->"Out[43]=",ExpressionUUID->"60ee45cf-7067-4546-8c9d-4c3acc1bf076"]
}, Open  ]],

Cell["\<\
Regardless 4 being coprime to 31, 4 is not a primitive root of 31:\
\>", "Text",
 CellFrame->{{0, 0}, {0, 0.5}},
 CellFrameColor->GrayLevel[0.75],
 CellChangeTimes->{{3.8751008661842065`*^9, 3.875100868873633*^9}, {
  3.8751010886551075`*^9, 
  3.8751011054165087`*^9}},ExpressionUUID->"dc333991-ad5e-433e-891d-\
a6f2b5bc528f"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Array", "[", 
  RowBox[{
   RowBox[{
    RowBox[{"PowerMod", "[", 
     RowBox[{"4", ",", "#", ",", "31"}], "]"}], "&"}], ",", "30"}], 
  "]"}]], "Input",
 CellChangeTimes->{{3.875101116748399*^9, 3.875101117673007*^9}, {
   3.875103022094956*^9, 3.8751030222268777`*^9}, 3.8751031031641426`*^9},
 CellLabel->"In[44]:=",ExpressionUUID->"0c863a7e-c99f-4b50-a707-93c6809d60e0"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "4", ",", "16", ",", "2", ",", "8", ",", "1", ",", "4", ",", "16", ",", "2",
    ",", "8", ",", "1", ",", "4", ",", "16", ",", "2", ",", "8", ",", "1", 
   ",", "4", ",", "16", ",", "2", ",", "8", ",", "1", ",", "4", ",", "16", 
   ",", "2", ",", "8", ",", "1", ",", "4", ",", "16", ",", "2", ",", "8", ",",
    "1"}], "}"}]], "Output",
 CellChangeTimes->{3.875101118666501*^9, 3.8751030225869694`*^9, 
  3.8751031036184297`*^9},
 CellLabel->"Out[44]=",ExpressionUUID->"b0f4d44c-7e2b-4956-a1ec-8ad2769d8bb5"]
}, Open  ]],

Cell[TextData[{
 "5 is a divisor of 30 and ",
 Cell[BoxData[
  FormBox[
   RowBox[{
    SuperscriptBox["4", "5"], "=", 
    RowBox[{
     RowBox[{"1", "  ", "->", " ", 
      SuperscriptBox["4", "30"]}], " ", "=", 
     RowBox[{"1", " ", 
      RowBox[{"(", 
       RowBox[{"mod", " ", "31"}], ")"}]}]}]}], TraditionalForm]],
  FormatType->TraditionalForm,ExpressionUUID->
  "69f51c42-e86c-4aa9-8df3-147f5f98a788"],
 ":"
}], "Text",
 CellChangeTimes->{{3.8751015438009586`*^9, 3.8751016542587137`*^9}, 
   3.8751017561845922`*^9},ExpressionUUID->"2380cca2-06a7-4cdb-8cbc-\
e10cee9e33a0"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{
    InterpretationBox[
     TagBox[
      DynamicModuleBox[{Typeset`open = False}, 
       FrameBox[
        PaneSelectorBox[{False->GridBox[{
           {
            PaneBox[GridBox[{
               {
                StyleBox[
                 StyleBox[
                  AdjustmentBox["\<\"[\[FilledSmallSquare]]\"\>",
                   BoxBaselineShift->-0.25,
                   BoxMargins->{{0, 0}, {-1, -1}}], "ResourceFunctionIcon",
                  
                  FontColor->RGBColor[
                   0.8745098039215686, 0.2784313725490196, 
                    0.03137254901960784]],
                 ShowStringCharacters->False,
                 FontFamily->"Source Sans Pro Black",
                 FontSize->0.6538461538461539 Inherited,
                 FontWeight->"Heavy",
                 PrivateFontOptions->{"OperatorSubstitution"->False}], 
                StyleBox[
                 RowBox[{
                  StyleBox["FractionMod", "ResourceFunctionLabel"], " "}],
                 ShowAutoStyles->False,
                 ShowStringCharacters->False,
                 FontSize->Rational[12, 13] Inherited,
                 FontColor->GrayLevel[0.1]]}
              },
              GridBoxSpacings->{"Columns" -> {{0.25}}}],
             Alignment->Left,
             BaseStyle->{LineSpacing -> {0, 0}, LineBreakWithin -> False},
             BaselinePosition->Baseline,
             FrameMargins->{{3, 0}, {0, 0}}], 
            ItemBox[
             PaneBox[
              TogglerBox[Dynamic[Typeset`open], {True->
               
               DynamicBox[FEPrivate`FrontEndResource[
                "FEBitmaps", "IconizeCloser"],
                
                ImageSizeCache->{
                 12.100000000000001`, {2., 10.100000000000001`}}], False->
               
               DynamicBox[FEPrivate`FrontEndResource[
                "FEBitmaps", "IconizeOpener"],
                
                ImageSizeCache->{
                 12.100000000000001`, {2., 10.100000000000001`}}]},
               Appearance->None,
               BaselinePosition->Baseline,
               ContentPadding->False,
               FrameMargins->0],
              Alignment->Left,
              BaselinePosition->Baseline,
              FrameMargins->{{1, 1}, {0, 0}}],
             Frame->{{
                RGBColor[
                0.8313725490196079, 0.8470588235294118, 0.8509803921568627, 
                 0.5], False}, {False, False}}]}
          },
          BaselinePosition->{1, 1},
          GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
          GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0}}}], True->
         GridBox[{
           {GridBox[{
              {
               PaneBox[GridBox[{
                  {
                   StyleBox[
                    AdjustmentBox[
                    
                    StyleBox["\<\"[\[FilledSmallSquare]]\"\>", 
                    "ResourceFunctionIcon",
                    
                    FontColor->RGBColor[
                    0.8745098039215686, 0.2784313725490196, 
                    0.03137254901960784]],
                    BoxBaselineShift->-0.25,
                    BoxMargins->{{0, 0}, {-1, -1}}],
                    ShowStringCharacters->False,
                    FontFamily->"Source Sans Pro Black",
                    FontSize->0.6538461538461539 Inherited,
                    FontWeight->"Heavy",
                    PrivateFontOptions->{"OperatorSubstitution"->False}], 
                   StyleBox[
                    RowBox[{
                    StyleBox["FractionMod", "ResourceFunctionLabel"], " "}],
                    ShowAutoStyles->False,
                    ShowStringCharacters->False,
                    FontSize->Rational[12, 13] Inherited,
                    FontColor->GrayLevel[0.1]]}
                 },
                 GridBoxSpacings->{"Columns" -> {{0.25}}}],
                Alignment->Left,
                BaseStyle->{LineSpacing -> {0, 0}, LineBreakWithin -> False},
                BaselinePosition->Baseline,
                FrameMargins->{{3, 0}, {0, 0}}], 
               ItemBox[
                PaneBox[
                 TogglerBox[Dynamic[Typeset`open], {True->
                  
                  DynamicBox[FEPrivate`FrontEndResource[
                   "FEBitmaps", "IconizeCloser"]], False->
                  
                  DynamicBox[FEPrivate`FrontEndResource[
                   "FEBitmaps", "IconizeOpener"]]},
                  Appearance->None,
                  BaselinePosition->Baseline,
                  ContentPadding->False,
                  FrameMargins->0],
                 Alignment->Left,
                 BaselinePosition->Baseline,
                 FrameMargins->{{1, 1}, {0, 0}}],
                Frame->{{
                   RGBColor[
                   0.8313725490196079, 0.8470588235294118, 0.8509803921568627,
                     0.5], False}, {False, False}}]}
             },
             BaselinePosition->{1, 1},
             GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
             
             GridBoxItemSize->{
              "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
             GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0}}}]},
           {
            StyleBox[
             PaneBox[GridBox[{
                {
                 RowBox[{
                  TagBox["\<\"Version (latest): \"\>",
                   "IconizedLabel"], " ", 
                  TagBox["\<\"1.0.0\"\>",
                   "IconizedItem"]}]},
                {
                 TagBox[
                  
                  TemplateBox[{
                   "\"Documentation \[RightGuillemet]\"", 
                    "https://resources.wolframcloud.com/FunctionRepository/\
resources/8da3d816-4280-4c8b-bf80-99265c8c1ccc/"},
                   "HyperlinkURL"],
                  "IconizedItem"]}
               },
               DefaultBaseStyle->"Column",
               GridBoxAlignment->{"Columns" -> {{Left}}},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
              Alignment->Left,
              BaselinePosition->Baseline,
              FrameMargins->{{5, 4}, {0, 4}}], "DialogStyle",
             FontFamily->"Roboto",
             FontSize->11]}
          },
          BaselinePosition->{1, 1},
          GridBoxAlignment->{"Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
          GridBoxDividers->{"Columns" -> {{None}}, "Rows" -> {False, {
               GrayLevel[0.8]}, False}},
          
          GridBoxItemSize->{
           "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]}, Dynamic[
         Typeset`open],
         BaselinePosition->Baseline,
         ImageSize->Automatic],
        Background->RGBColor[
         0.9686274509803922, 0.9764705882352941, 0.984313725490196],
        BaselinePosition->Baseline,
        DefaultBaseStyle->{},
        FrameMargins->{{0, 0}, {1, 0}},
        FrameStyle->RGBColor[
         0.8313725490196079, 0.8470588235294118, 0.8509803921568627],
        RoundingRadius->4]],
      {"FunctionResourceBox", 
       RGBColor[0.8745098039215686, 0.2784313725490196, 0.03137254901960784], 
       "FractionMod"},
      TagBoxNote->"FunctionResourceBox"],
     ResourceFunction[
      ResourceObject[<|
       "Name" -> "FractionMod", "ShortName" -> "FractionMod", "UUID" -> 
        "8da3d816-4280-4c8b-bf80-99265c8c1ccc", "ResourceType" -> "Function", 
        "Version" -> "1.0.0", "Description" -> 
        "Get a congruent integer for a given fraction and modulus", 
        "RepositoryLocation" -> 
        URL["https://www.wolframcloud.com/obj/resourcesystem/api/1.0"], 
        "SymbolName" -> 
        "FunctionRepository`$24066e1a402e41a2bac62dcf620303bc`FractionMod", 
        "FunctionLocation" -> 
        CloudObject[
         "https://www.wolframcloud.com/obj/5623256c-9dea-469c-985c-\
1aa5d136ef5d"]|>, ResourceSystemBase -> Automatic]],
     Selectable->False], "[", 
    RowBox[{
     RowBox[{"1", "/", "4"}], ",", "31"}], "]"}], ",", 
   RowBox[{"Mod", "[", 
    RowBox[{
     RowBox[{"4", "^", "4"}], ",", "31"}], "]"}]}], "}"}]], "Input",
 CellChangeTimes->{{3.8751011424709263`*^9, 3.8751012374083295`*^9}},
 CellLabel->"In[34]:=",ExpressionUUID->"0a10ac70-c3b3-4a3c-a338-36e527a2edb3"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{"8", ",", "8"}], "}"}]], "Output",
 CellFrame->{{0, 0}, {0.5, 0}},
 CellFrameColor->GrayLevel[0.75],
 CellChangeTimes->{{3.8751011728693666`*^9, 3.875101197935033*^9}, 
   3.8751012378995843`*^9},
 CellLabel->"Out[34]=",ExpressionUUID->"9bb28642-2459-4728-baaf-4577d08c551f"]
}, Open  ]],

Cell[CellGroupData[{

Cell["Graph primitive root power rearrangement", "Subsection",
 CellChangeTimes->{{3.875103512905901*^9, 
  3.87510354549994*^9}},ExpressionUUID->"1b1cebc2-46a4-4c72-8195-\
3296be0beae7"],

Cell["For primitive root {3,11,12,13,17,21,22,24} :", "Text",
 CellChangeTimes->{{3.8751017119130764`*^9, 3.875101717194754*^9}, {
  3.8751035893675146`*^9, 
  3.875103590232069*^9}},ExpressionUUID->"a08d58be-22a9-46bf-80b8-\
995c8efa40e7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"mod", "=", 
  RowBox[{"Array", "[", 
   RowBox[{
    RowBox[{
     RowBox[{"PowerMod", "[", 
      RowBox[{"3", ",", "#", ",", "31"}], "]"}], "&"}], ",", "30"}], 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.8751035515186768`*^9, 3.875103551678415*^9}, {
  3.875103592897732*^9, 3.875103592998693*^9}, {3.875103664520949*^9, 
  3.8751036921321697`*^9}},
 CellLabel->"In[87]:=",ExpressionUUID->"495c5d36-b05d-4edd-92b4-cfbb5e982c5e"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "3", ",", "9", ",", "27", ",", "19", ",", "26", ",", "16", ",", "17", ",", 
   "20", ",", "29", ",", "25", ",", "13", ",", "8", ",", "24", ",", "10", ",",
    "30", ",", "28", ",", "22", ",", "4", ",", "12", ",", "5", ",", "15", ",",
    "14", ",", "11", ",", "2", ",", "6", ",", "18", ",", "23", ",", "7", ",", 
   "21", ",", "1"}], "}"}]], "Output",
 CellChangeTimes->{
  3.875103554494172*^9, 3.875103595605975*^9, {3.875103665120683*^9, 
   3.8751037034018707`*^9}},
 CellLabel->"Out[87]=",ExpressionUUID->"8542aa06-d858-4616-ba49-068718a9bfb4"]
}, Open  ]],

Cell[BoxData[
 RowBox[{
  RowBox[{"base", "=", 
   RowBox[{"Range", "[", "30", "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.872969377476343*^9, 3.872969383863758*^9}, 
   3.8751005357406993`*^9},
 CellLabel->"In[88]:=",ExpressionUUID->"a04efb9a-b3e5-4c04-92e3-d38a4bdd0b46"],

Cell["Check how remainder and power are shuffled:", "Text",
 CellChangeTimes->{{3.875100545669304*^9, 
  3.875100570334972*^9}},ExpressionUUID->"2d7a3ced-51ce-4c67-a15f-\
5ff924d87970"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"components", "=", 
  RowBox[{"WeaklyConnectedComponents", "[", 
   RowBox[{"Graph", "@", 
    RowBox[{"Thread", "[", 
     RowBox[{"base", "\[DirectedEdge]", "mod"}], "]"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8729693893948574`*^9, 3.872969444559102*^9}, {
  3.8729709289891634`*^9, 3.8729709297277193`*^9}, {3.8729711301959925`*^9, 
  3.8729711365606365`*^9}, {3.872971241386676*^9, 3.8729712547722616`*^9}},
 CellLabel->"In[89]:=",ExpressionUUID->"c877bec9-c6ec-4d9e-9907-ba02d68440e9"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{
    "23", ",", "27", ",", "11", ",", "3", ",", "13", ",", "1", ",", "24", ",",
      "30", ",", "2", ",", "15", ",", "9", ",", "21", ",", "29"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "6", ",", "25", ",", "16", ",", "10", ",", "28", ",", "14", ",", "7", ",",
      "22", ",", "17"}], "}"}], ",", 
   RowBox[{"{", 
    RowBox[{
    "18", ",", "26", ",", "4", ",", "5", ",", "19", ",", "20", ",", "12", ",",
      "8"}], "}"}]}], "}"}]], "Output",
 CellChangeTimes->{
  3.872970930237559*^9, 3.872971136926972*^9, 3.872971255169484*^9, 
   3.873327356480559*^9, 3.874847969612628*^9, 3.8748480501031923`*^9, 
   3.8749496826109867`*^9, 3.875101675527733*^9, 3.875103554547639*^9, 
   3.8751035956566544`*^9, {3.8751036748420124`*^9, 3.8751037034535723`*^9}},
 CellLabel->"Out[89]=",ExpressionUUID->"36d0ca64-877a-4ed2-9bc2-511cdf1de5f3"]
}, Open  ]],

Cell["check one of the subgraph:", "Text",
 CellChangeTimes->{{3.8751036052598333`*^9, 
  3.875103621550265*^9}},ExpressionUUID->"7f89c926-5238-40f5-ab7a-\
d040202f652d"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"sg", "=", 
  RowBox[{"Subgraph", "[", 
   RowBox[{
    RowBox[{"Graph", "@", 
     RowBox[{"Thread", "[", 
      RowBox[{"base", "\[DirectedEdge]", "mod"}], "]"}]}], ",", 
    RowBox[{"components", "[", 
     RowBox[{"[", "1", "]"}], "]"}], ",", 
    RowBox[{"VertexLabels", "->", "\"\<Name\>\""}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.872971310006009*^9, 3.8729713550105276`*^9}, {
  3.872972047696332*^9, 3.8729720524622297`*^9}, {3.872972788692563*^9, 
  3.872972793292631*^9}},
 CellLabel->"In[90]:=",ExpressionUUID->"adf2d840-d939-4a14-b7c7-417d2844f9c9"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{23, 27, 11, 3, 13, 1, 24, 30, 2, 15, 9, 21, 
      29}, {{{2, 1}, {1, 3}, {4, 2}, {3, 5}, {6, 4}, {5, 7}, {8, 6}, {7, 9}, {
       10, 8}, {9, 11}, {12, 10}, {13, 12}, {11, 13}}, Null}, {
      VertexLabels -> {"Name"}}]]}, 
    TagBox[GraphicsGroupBox[{
       {Hue[0.6, 0.7, 0.5], Opacity[0.7], Arrowheads[Medium], 
        ArrowBox[CompressedData["
1:eJxTTMoPSmVmYGDgBWImKO44ku7Etu/u/rcO7A+Wh76xv3Z4idOj0Ff7FQSX
y03TfWTP1TXPx7JylQ0DGHywJ6Q+K31amuuR9/sl7Ve9rr29z74Cot7+EVQ9
unno6l0ZP+ktf/12/6RYs003Nl7bfwVivr0A1Hx089DVN+j7MPlaPN3Posd8
4czn5/szIebbz7eDmI9uHrr6Tb1HvJ8uPLf/nw3r5C+C7/d7Qsy33wY1H908
dPVnIXx7ZlsIvxVivr041Hx08wipBwCcQdYw
         "], 0.022493035754179463`]}, 
       {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[
        0.7]}], {
         DiskBox[{-0.46472317204376923, 0.8854560256532104}, 
          0.022493035754179463], 
         InsetBox["23", 
          Offset[{2, 2}, {-0.44223013628958974, 0.9079490614073898}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{1.8369701987210297*^-16, 1.}, 0.022493035754179463], 
         InsetBox["27", 
          Offset[{2, 2}, {0.022493035754179647, 1.0224930357541795}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.8229838658936568, 0.5680647467311566}, 
          0.022493035754179463], 
         InsetBox["11", 
          Offset[{2, 2}, {-0.8004908301394773, 0.5905577824853361}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.46472317204376834, 0.8854560256532091}, 
          0.022493035754179463], 
         InsetBox["3", 
          Offset[{2, 2}, {0.48721620779794783, 0.9079490614073886}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.9927088740980541, 0.12053668025532395}, 
          0.022493035754179463], 
         InsetBox["13", 
          Offset[{2, 2}, {-0.9702158383438746, 0.14302971600950343}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.8229838658936566, 0.5680647467311548}, 
          0.022493035754179463], 
         InsetBox["1", 
          Offset[{2, 2}, {0.8454769016478361, 0.5905577824853343}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.9350162426854146, -0.3546048870425348}, 
          0.022493035754179463], 
         InsetBox["24", 
          Offset[{2, 2}, {-0.9125232069312351, -0.3321118512883553}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.992708874098054, 0.12053668025532226}, 
          0.022493035754179463], 
         InsetBox["30", 
          Offset[{2, 2}, {1.0152019098522334, 0.1430297160095017}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.6631226582407947, -0.7485107481711002}, 
          0.022493035754179463], 
         InsetBox["2", 
          Offset[{2, 2}, {-0.6406296224866153, -0.7260177124169207}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.935016242685415, -0.3546048870425368}, 
          0.022493035754179463], 
         InsetBox["15", 
          Offset[{2, 2}, {0.9575092784395945, -0.3321118512883573}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.2393156642875574, -0.9709418174260518}, 
          0.022493035754179463], 
         InsetBox["9", 
          Offset[{2, 2}, {-0.21682262853337794, -0.9484487816718723}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.6631226582407953, -0.7485107481711023}, 
          0.022493035754179463], 
         InsetBox["21", 
          Offset[{2, 2}, {0.6856156939949748, -0.7260177124169228}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.23931566428755816, -0.9709418174260523}, 
          0.022493035754179463], 
         InsetBox["29", 
          Offset[{2, 2}, {0.2618087000417376, -0.9484487816718729}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FormatType->TraditionalForm,
  FrameTicks->None,
  ImageSize->{313.4294871794871, Automatic}]], "Output",
 CellChangeTimes->{{3.8729713296530385`*^9, 3.8729713555210853`*^9}, 
   3.872972052850848*^9, 3.872972793621931*^9, 3.873327357864131*^9, 
   3.8748479697253723`*^9, 3.8748480534622207`*^9, 3.8749496826911173`*^9, 
   3.875101678722798*^9, 3.875103554612772*^9, 3.875103595705304*^9, {
   3.8751036748899884`*^9, 3.875103703506069*^9}},
 CellLabel->"Out[90]=",ExpressionUUID->"3009ce6e-1398-4b66-b1f9-165339e72d50"]
}, Open  ]],

Cell["\<\
Poincare hyperbolic arc shows how the above cycle related to the original \
arrangement:\
\>", "Text",
 CellChangeTimes->{{3.8751019868448067`*^9, 
  3.875102035125365*^9}},ExpressionUUID->"553cd463-5816-4604-9a34-\
d0a16e3b132e"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"g", "=", 
  RowBox[{"Graph", "[", 
   RowBox[{
    RowBox[{"Thread", "[", 
     RowBox[{"base", "\[DirectedEdge]", "mod"}], "]"}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"VertexLabels", "->", "\"\<Name\>\""}], ",", 
    "\[IndentingNewLine]", 
    RowBox[{"VertexCoordinates", "\[Rule]", 
     RowBox[{"Thread", "[", 
      RowBox[{
       RowBox[{"Range", "[", "30", "]"}], "->", 
       RowBox[{"CirclePoints", "[", 
        RowBox[{
         RowBox[{"{", 
          RowBox[{"1", ",", 
           RowBox[{"\[Pi]", "/", "2"}]}], "}"}], ",", "30"}], "]"}]}], 
      "]"}]}], ",", "\[IndentingNewLine]", 
    RowBox[{"EdgeShapeFunction", "\[Rule]", "HyperbolicLineEdge"}], ",", 
    RowBox[{"EdgeStyle", "->", 
     RowBox[{"Opacity", "[", "0.3", "]"}]}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.8729695239413214`*^9, 3.8729695490392094`*^9}, {
   3.8729696409188843`*^9, 3.872969649880358*^9}, {3.8729710865141325`*^9, 
   3.872971106930802*^9}, {3.8729716089457655`*^9, 3.872971638098901*^9}, {
   3.87297167613587*^9, 3.8729717000901585`*^9}, {3.8729719221596546`*^9, 
   3.8729719278973846`*^9}, {3.872971958113331*^9, 3.8729719720085125`*^9}, 
   3.872972394078395*^9},
 CellLabel->"In[91]:=",ExpressionUUID->"6ace2071-4403-4126-b5df-2474a229716e"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 3, 2, 9, 27, 4, 19, 5, 26, 6, 16, 7, 17, 8, 20, 29, 10, 25, 11,
       13, 12, 24, 14, 15, 30, 28, 22, 18, 21, 
      23}, {{{1, 2}, {3, 4}, {2, 5}, {6, 7}, {8, 9}, {10, 11}, {12, 13}, {14, 
       15}, {4, 16}, {17, 18}, {19, 20}, {21, 14}, {20, 22}, {23, 17}, {24, 
       25}, {11, 26}, {13, 27}, {28, 6}, {7, 21}, {15, 8}, {29, 24}, {27, 
       23}, {30, 19}, {22, 3}, {18, 10}, {9, 28}, {5, 30}, {26, 12}, {16, 
       29}, {25, 1}}, Null}, {
      EdgeShapeFunction -> {$CellContext`HyperbolicLineEdge}, EdgeStyle -> {
         Opacity[0.3]}, VertexLabels -> {"Name"}, 
       VertexCoordinates -> {{0, 1}, {-Sin[Rational[2, 15] Pi], 
          Cos[Rational[2, 15] Pi]}, {-Sin[Rational[1, 15] Pi], 
          Cos[Rational[1, 15] Pi]}, {-Cos[Rational[1, 30] Pi], -
          Sin[Rational[1, 30] Pi]}, {
          Cos[Rational[7, 30] Pi], 
          Sin[
          Rational[7, 30] 
           Pi]}, {-(Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2])^
           Rational[1, 2], 
          Rational[1, 4] (1 + 5^Rational[1, 2])}, {(Rational[5, 8] + 
           Rational[-1, 8] 5^Rational[1, 2])^Rational[1, 2], 
          Rational[1, 4] (-1 - 5^Rational[1, 2])}, {-Cos[Rational[7, 30] Pi], 
          Sin[Rational[7, 30] Pi]}, {Rational[1, 2] 3^Rational[1, 2], 
          Rational[1, 2]}, {Rational[-1, 2] 3^Rational[1, 2], 
          Rational[1, 2]}, {
         0, -1}, {-(Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2])^
           Rational[1, 2], Rational[1, 4] (-1 + 5^Rational[1, 2])}, {
          Sin[Rational[1, 15] Pi], -Cos[Rational[1, 15] Pi]}, {-
          Cos[Rational[1, 30] Pi], 
          Sin[Rational[1, 30] Pi]}, {
          Cos[Rational[7, 30] Pi], -Sin[Rational[7, 30] Pi]}, {
          Sin[Rational[2, 15] Pi], 
          Cos[
          Rational[2, 15] 
           Pi]}, {-(Rational[5, 8] + Rational[1, 8] 5^Rational[1, 2])^
           Rational[1, 2], 
          Rational[1, 4] (1 - 5^Rational[1, 2])}, {(Rational[5, 8] + 
           Rational[1, 8] 5^Rational[1, 2])^Rational[1, 2], 
          Rational[1, 4] (-1 + 5^Rational[1, 2])}, {
         Rational[-1, 2] 3^Rational[1, 2], 
          
          Rational[-1, 
           2]}, {-(Rational[5, 8] + Rational[-1, 8] 5^Rational[1, 2])^
           Rational[1, 2], Rational[1, 4] (-1 - 5^Rational[1, 2])}, {-
          Cos[Rational[7, 30] Pi], -Sin[Rational[7, 30] Pi]}, {
          Cos[Rational[1, 30] Pi], 
          Sin[Rational[1, 30] Pi]}, {-Sin[Rational[2, 15] Pi], -
          Cos[Rational[2, 15] Pi]}, {-Sin[Rational[1, 15] Pi], -
          Cos[Rational[1, 15] Pi]}, {
          Sin[Rational[1, 15] Pi], 
          Cos[
          Rational[1, 15] Pi]}, {(Rational[5, 8] + 
           Rational[-1, 8] 5^Rational[1, 2])^Rational[1, 2], 
          Rational[1, 4] (1 + 5^Rational[1, 2])}, {(Rational[5, 8] + 
           Rational[1, 8] 5^Rational[1, 2])^Rational[1, 2], 
          Rational[1, 4] (1 - 5^Rational[1, 2])}, {
          Sin[Rational[2, 15] Pi], -Cos[Rational[2, 15] Pi]}, {
         Rational[1, 2] 3^Rational[1, 2], 
          Rational[-1, 2]}, {
          Cos[Rational[1, 30] Pi], -Sin[Rational[1, 30] Pi]}}}]]}, 
    TagBox[GraphicsGroupBox[{
       {Hue[0.6, 0.7, 0.5], Opacity[0.3], 
        {Thickness[0.003], Arrowheads[{0, -0.022, -0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{-0.40673664307580015`, 
          0.9135454576426009}, {-0.37612148394740325`, 
          0.844782684401292}, {-0.30905522132551533`, 
          0.8106107167929633}, {-0.24198895870362733`, 
          0.7764387491846343}, {-0.1683635675387986, 
          0.7920883091822408}, {-0.09473817637396988, 
          0.8077378691798472}, {-0.047369088186985014`, 
          0.8662338214896129}, {-2.220446049250313*^-16, 
          0.9247297737993785}, {-2.220446049250313*^-16, 1.}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9426414910921784, 1, 0.9426414910921784, 1, 
            0.9426414910921784, 1, 0.9426414910921784, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, 0.022, 0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{-0.4067366430758001, 
          0.9135454576426012}, {-0.33579061633009694`, 
          0.7541980726093598}, {-0.20023504467100195`, 
          0.6444273350692029}, {-0.06467947301190652, 0.5346565975290458}, {
          0.10593629771906585`, 0.49839109593578956`}, {0.2765520684500376, 
          0.4621255943425333}, {0.4450360264923885, 0.5072707348375805}, {
          0.6135199845347394, 0.5524158753326277}, {0.7431448254773941, 
          0.6691306063588585}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9723699203976766, 1, 0.9723699203976766, 1, 
            0.9723699203976766, 1, 0.9723699203976766, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, -0.022, -0.022, 0}], 
         ArrowBox[
          BSplineCurveBox[{{-0.9945218953682735, -0.10452846326765364`}, \
{-0.8041835444470748, -0.08452309645235112}, {-0.6384377242897867, 
          0.01117029743251452}, {-0.47269190413249873`, 
          0.10686369131738005`}, {-0.36019757279782105`, 
          0.26169885512192403`}, {-0.2477032414631436, 
          0.41653401892646785`}, {-0.20791169081775907`, 
          0.6037385461955804}, {-0.16812014017237453`, 
          0.7909430734646931}, {-0.20791169081775895`, 0.9781476007338058}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9781476007338057, 1, 0.9781476007338057, 1, 
            0.9781476007338057, 1, 0.9781476007338057, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, 0.022, 0.022, 0}], 
         ArrowBox[
          BSplineCurveBox[{{-0.9945218953682742, -0.10452846326765353`}, \
{-0.7677422463098955, -0.08069296167955442}, {-0.5548590081682061, 
          0.0010252571049198522`}, {-0.34197577002651824`, 
          0.08274347588939324}, {-0.15749658367469244`, 
          0.21677545030582124`}, {0.026982602677133816`, 0.350807424722249}, {
          0.1704857855554911, 0.5280190972124617}, {0.31398896843384927`, 
          0.7052307697026756}, {0.40673664307580015`, 0.9135454576426011}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9914448613738104, 1, 0.9914448613738104, 1, 
            0.9914448613738104, 1, 0.9914448613738104, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, 0.022, 0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{0.7431448254773942, 0.6691306063588585}, {
          0.6451368460109672, 0.580883825273828}, {0.6110030799020089, 
          0.4534948759015227}, {0.5768693137930505, 0.32610592652921727`}, {
          0.6176233232420445, 0.20067798257416336`}, {0.6583773326910387, 
          0.0752500386191095}, {0.760869475301279, -0.007746461994608933}, {
          0.8633616179115196, -0.09074296260832743}, {
          0.9945218953682731, -0.10452846326765358`}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.958819734868193, 1, 0.958819734868193, 1, 0.958819734868193, 
            1, 0.958819734868193, 1}]]}, 
        {Thickness[0.004], Arrowheads[{0.03}], 
         ArrowBox[{{-0.5877852522924731, 0.8090169943749475}, {
          0.5877852522924731, -0.8090169943749475}}]}, 
        {Thickness[0.003], Arrowheads[{0, 0.022, 0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{
          0.5877852522924731, -0.8090169943749475}, {
          0.4752909209577957, -0.6541818305704036}, {
          0.30954510080050746`, -0.558488436685538}, {
          0.14379928064321953`, -0.4627950428006725}, {-0.04653907027797899, \
-0.44278967598537}, {-0.23687742119917754`, -0.4227843091700675}, \
{-0.4188970728403778, -0.4819260790897456}, {-0.6009167244815785, \
-0.5410678490094241}, {-0.7431448254773942, -0.6691306063588582}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9781476007338057, 1, 0.9781476007338057, 1, 
            0.9781476007338057, 1, 0.9781476007338057, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, 0.022, 0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{-0.7431448254773946, 
          0.6691306063588585}, {-0.5811411261393107, 
          0.5232618202836363}, {-0.38199051837381726`, 
          0.4345942570098096}, {-0.18283991060832375`, 
          0.34592669373598284`}, {0.03396335653261742, 
          0.32313975214003365`}, {0.2507666236735586, 0.3003528105440849}, {
          0.46400033584500733`, 0.34567703523538285`}, {0.6772340480164559, 
          0.391001259926681}, {0.8660254037844378, 0.49999999999999933`}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9876883405951378, 1, 0.9876883405951378, 1, 
            0.9876883405951378, 1, 0.9876883405951378, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, 0.022, 0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{0.8660254037844388, 0.5}, {
          0.687762853499002, 0.3970800686062739}, {0.5582236305559578, 
          0.23711245053414864`}, {0.4286844076129134, 0.0771448324620232}, {
          0.3650763918917834, -0.11862051035528365`}, {
          0.30146837617065314`, -0.31438585317258994`}, {
          0.3122412022225509, -0.5199436195819688}, {
          0.3230140282744485, -0.7255013859913471}, {
          0.40673664307579993`, -0.9135454576426004}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9832549075639546, 1, 0.9832549075639546, 1, 
            0.9832549075639546, 1, 0.9832549075639546, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, -0.022, -0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{2.220446049250313*^-16, -1.}, {
          2.220446049250313*^-16, -0.7719711852352913}, \
{-0.05901820009326131, -0.5517122639159731}, {-0.11803640018652262`, \
-0.3314533425966548}, {-0.23205080756887697`, -0.13397459621556118`}, \
{-0.3460652149512311, 0.06350415016553268}, {-0.507305936177288, 
          0.2247448713915896}, {-0.6685466574033447, 
          0.3859855926176461}, {-0.8660254037844385, 0.5000000000000004}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9914448613738104, 1, 0.9914448613738104, 1, 
            0.9914448613738104, 1, 0.9914448613738104, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, -0.022, -0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{0.5877852522924734, 0.8090169943749477}, {
          0.44541252716042345`, 0.6130577495349827}, {0.3354474261649698, 
          0.39723908708236944`}, {0.22548232516951483`, 0.1814204246297566}, {
          0.1506325540504112, -0.04894348370484625}, {
          0.07578278293130669, -0.27930739203944865`}, {
          0.03789139146565379, -0.5185442222988634}, \
{-4.440892098500626*^-16, -0.7577810525582781}, {0., -0.9999999999999997}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.996917333733128, 1, 0.996917333733128, 1, 0.996917333733128, 
            1, 0.996917333733128, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, -0.022, -0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{
          0.2079116908177594, -0.9781476007338057}, {
          0.1605018343848592, -0.7551017626735324}, {
          0.05697891881481243, -0.5519266010152363}, {-0.04654399675523413, \
-0.34875143935693986`}, {-0.19912505584603535`, -0.17929300560480366`}, \
{-0.35170611493683657`, -0.009834571852666896}, {-0.5429471705234766, 
          0.11435882177640422`}, {-0.7341882261101167, 
          0.23855221540547555`}, {-0.9510565162951535, 0.30901699437494745`}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9914448613738104, 1, 0.9914448613738104, 1, 
            0.9914448613738104, 1, 0.9914448613738104, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, -0.022, -0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{
          0.9510565162951535, -0.30901699437494745`}, {
          0.8039275611951979, -0.26121189897680497`}, {
          0.652607600747305, -0.2933759494816528}, {
          0.5012876402994122, -0.3255399999865006}, {
          0.3863227357043044, -0.4290548650362509}, {
          0.27135783110919653`, -0.5325697300860014}, {
          0.22355273571105394`, -0.6796986851859571}, {
          0.17574764031291146`, -0.8268276402859126}, {
          0.20791169081775918`, -0.9781476007338054}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9659258262890683, 1, 0.9659258262890683, 1, 
            0.9659258262890683, 1, 0.9659258262890683, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, -0.022, -0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{0.743144825477394, -0.6691306063588582}, {
          0.5631410680534981, -0.5070544951855749}, {
          0.3599991658354065, -0.3751326013885601}, {
          0.15685726361731533`, -0.24321070759154528`}, \
{-0.06442075557304139, -0.1446913860197463}, {-0.2856987747633979, \
-0.046172064447946415`}, {-0.5196643117139111, 
          0.016518812234657343`}, {-0.7536298486644242, 
          0.07920968891726199}, {-0.9945218953682733, 0.10452846326765286`}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.996917333733128, 1, 0.996917333733128, 1, 0.996917333733128, 
            1, 0.996917333733128, 1}]]}, 
        {Thickness[0.004], Arrowheads[{0.03}], 
         ArrowBox[{{
          0.7431448254773942, -0.6691306063588582}, {-0.7431448254773942, 
          0.6691306063588582}}]}, 
        {Thickness[0.003], Arrowheads[{0, 0.022, 0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{0.40673664307580015`, 
          0.9135454576426008}, {0.3230140282744485, 0.7255013859913473}, {
          0.3122412022225509, 0.5199436195819686}, {0.30146837617065314`, 
          0.31438585317259016`}, {0.3650763918917834, 0.11862051035528343`}, {
          0.4286844076129136, -0.07714483246202342}, {
          0.5582236305559577, -0.23711245053414853`}, {
          0.6877628534990021, -0.3970800686062742}, {
          0.866025403784439, -0.5000000000000001}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9832549075639546, 1, 0.9832549075639546, 1, 
            0.9832549075639546, 1, 0.9832549075639546, 1}]]}, 
        {Thickness[0.004], Arrowheads[{0.03}], 
         ArrowBox[{{-0.9510565162951535, -0.30901699437494745`}, {
          0.9510565162951535, 0.30901699437494745`}}]}, 
        {Thickness[0.003], Arrowheads[{0, -0.022, -0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{-0.8660254037844395, 
          0.5000000000000002}, {-0.6615845382496093, 
          0.38196601125010554`}, {-0.43707054995981515`, 
          0.30901699437494745`}, {-0.21255656167002318`, 
          0.2360679774997898}, {0.02221821074882188, 0.2113921545850337}, {
          0.25699298316766894`, 0.18671633167027757`}, {0.491767755586514, 
          0.21139215458503324`}, {0.726542528005361, 0.2360679774997898}, {
          0.951056516295153, 0.309016994374947}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9945218953682733, 1, 0.9945218953682733, 1, 
            0.9945218953682733, 1, 0.9945218953682733, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, -0.022, -0.022, 0}], 
         ArrowBox[
          BSplineCurveBox[{{-0.587785252292473, -0.8090169943749477}, \
{-0.5435425233950291, -0.7481221022081983}, {-0.5474818626598613, \
-0.6729550312365999}, {-0.5514212019246935, -0.5977879602650016}, \
{-0.6017868140230839, -0.5418512811514966}, {-0.6521524261214742, \
-0.48591460203799164`}, {-0.7264959509337868, -0.4741397444688402}, \
{-0.8008394757460995, -0.4623648868996887}, {-0.8660254037844388, \
-0.49999999999999944`}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9426414910921784, 1, 0.9426414910921784, 1, 
            0.9426414910921784, 1, 0.9426414910921784, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, -0.022, -0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{0.9945218953682732, 0.1045284632676533}, {
          0.7597471229494276, 0.07985264035289763}, {0.5352331346596352, 
          0.006903623477739984}, {0.3107191463698421, -0.0660453933974181}, {
          0.10627828083501067`, -0.184079382147313}, {-0.09816258469981975, \
-0.3021133708972077}, {-0.2735952806397026, -0.4600736798235512}, \
{-0.4490279765795857, -0.6180339887498953}, {-0.5877852522924729, \
-0.8090169943749472}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9945218953682733, 1, 0.9945218953682733, 1, 
            0.9945218953682733, 1, 0.9945218953682733, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, 0.022, 0.022, 0}], 
         ArrowBox[
          BSplineCurveBox[{{-0.743144825477394, -0.6691306063588582}, \
{-0.6451368460109672, -0.5808838252738278}, {-0.6110030799020087, \
-0.45349487590152243`}, {-0.5768693137930505, -0.3261059265292171}, \
{-0.6176233232420445, -0.20067798257416322`}, {-0.6583773326910387, \
-0.0752500386191094}, {-0.7608694753012792, 
          0.0077464619946090996`}, {-0.8633616179115198, 
          0.09074296260832754}, {-0.9945218953682733, 0.10452846326765358`}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.958819734868193, 1, 0.958819734868193, 1, 0.958819734868193, 
            1, 0.958819734868193, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, -0.022, -0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{-0.2079116908177595, 
          0.9781476007338059}, {-0.165115176907925, 
          0.7768058328128836}, {-0.053006752671741486`, 0.6041739981831232}, {
          0.059101671564442015`, 0.4315421635533624}, {0.22562961867929843`, 
          0.3105525278729915}, {0.3921575657941538, 0.18956289219262112`}, {
          0.5909836053403531, 0.13628761546193857`}, {0.7898096448865505, 
          0.08301233873125602}, {0.994521895368273, 0.10452846326765308`}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9832549075639546, 1, 0.9832549075639546, 1, 
            0.9832549075639546, 1, 0.9832549075639546, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, 0.022, 0.022, 0}], 
         ArrowBox[
          BSplineCurveBox[{{-0.4067366430758005, -0.9135454576426009}, \
{-0.3530950981222872, -0.7930645750679739}, {-0.3737261047738577, \
-0.662805525572349}, {-0.3943571114254284, -0.532546476076724}, \
{-0.48260389251045865`, -0.4345384966102971}, {-0.5708506735954891, \
-0.3365305171438703}, {-0.6982396229677944, -0.3023967510349118}, \
{-0.8256285723400996, -0.2682629849259535}, {-0.9510565162951535, \
-0.3090169943749476}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.958819734868193, 1, 0.958819734868193, 1, 0.958819734868193, 
            1, 0.958819734868193, 1}]]}, 
        {Thickness[0.004], Arrowheads[{0.03}], 
         ArrowBox[{{-0.20791169081775931`, -0.9781476007338057}, {
          0.20791169081775931`, 0.9781476007338057}}]}, 
        {Thickness[0.003], Arrowheads[{0, -0.022, -0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{-3.7470027081099033`*^-16, 
          1.}, {-3.608224830031759*^-16, 0.9596542641516057}, {
          0.02699656669223001, 0.9296715393257937}, {0.05399313338446037, 
          0.8996888144999817}, {0.09411785107043316, 0.8954715367323464}, {
          0.13424256875640594`, 0.8912542589647111}, {0.16688295470831938`, 
          0.914968887489285}, {0.19952334066023292`, 0.9386835160138589}, {
          0.20791169081775926`, 0.9781476007338057}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9335804264972017, 1, 0.9335804264972017, 1, 
            0.9335804264972017, 1, 0.9335804264972017, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, -0.022, -0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{-0.9510565162951536, 
          0.30901699437494745`}, {-0.743728592265771, 
          0.24165206827872154`}, {-0.5257311121191338, 
          0.24165206827872132`}, {-0.30773363197249665`, 
          0.24165206827872154`}, {-0.10040570794311393`, 
          0.30901699437494723`}, {0.10692221608626873`, 
          0.37638192047117336`}, {0.2832858822558134, 0.5045176243382878}, {
          0.4596495484253581, 0.6326533282054024}, {0.5877852522924728, 
          0.809016994374947}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9876883405951378, 1, 0.9876883405951378, 1, 
            0.9876883405951378, 1, 0.9876883405951378, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, 0.022, 0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{
          0.9510565162951534, -0.3090169943749477}, {
          0.7552911734778469, -0.2454089786538174}, {
          0.5497334070684684, -0.25618180470571517`}, {
          0.34417564065908957`, -0.2669546307576127}, {
          0.15613156900783642`, -0.3506772455589644}, {-0.03191250264341661, \
-0.43439986036031586`}, {-0.17746326545893265`, -0.5799506231758319}, \
{-0.3230140282744487, -0.7255013859913478}, {-0.40673664307580004`, \
-0.9135454576426008}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9832549075639546, 1, 0.9832549075639546, 1, 
            0.9832549075639546, 1, 0.9832549075639546, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, 0.022, 0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{
          0.40673664307580104`, -0.9135454576426003}, {
          0.30540129909109126`, -0.6859425485567057}, {
          0.1922930157827576, -0.4639550434761208}, {
          0.0791847324744257, -0.2419675383955351}, {-0.045386468215040665`, \
-0.026203889641520206`}, {-0.1699576689045088, 
          0.18955975911249556`}, {-0.3056503459728557, 
          0.3985081583762513}, {-0.4413430230412043, 
          0.6074565576400062}, {-0.5877852522924725, 0.8090169943749483}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9996573249755573, 1, 0.9996573249755573, 1, 
            0.9996573249755573, 1, 0.9996573249755573, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, 0.022, 0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{0.8660254037844386, -0.5}, {
          0.7149668195498755, -0.4127862857287713}, {
          0.5407784377360845, -0.40365745946100406`}, {
          0.36659005592229355`, -0.3945286331932367}, {
          0.20724267088905213`, -0.46547465993894}, {
          0.047895285855810765`, -0.536420686684643}, {-0.06187545168434616, \
-0.6719762583437383}, {-0.17164618922450303`, -0.8075318300028336}, \
{-0.2079116908177593, -0.9781476007338056}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.9723699203976766, 1, 0.9723699203976766, 1, 
            0.9723699203976766, 1, 0.9723699203976766, 1}]]}, 
        {Thickness[0.003], Arrowheads[{0, 0.022, 0.022, 0}], 
         ArrowBox[BSplineCurveBox[{{
          0.9945218953682732, -0.10452846326765375`}, {
          0.7536298486644242, -0.07920968891726154}, {
          0.5117428538719553, -0.0918864491517839}, {
          0.26985585907948634`, -0.10456320938630537`}, {
          0.03292997678709808, -0.15492336029701193`}, \
{-0.20399590550528945`, -0.20528351120771804`}, {-0.4301267737636352, \
-0.292087018743429}, {-0.6562576420219808, -0.3788905262791391}, \
{-0.8660254037844393, -0.5}},
          SplineDegree->2,
          SplineKnots->{0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 4},
          
          SplineWeights->{
           1, 0.996917333733128, 1, 0.996917333733128, 1, 0.996917333733128, 
            1, 0.996917333733128, 1}]]}}, 
       {Hue[0.6, 0.2, 0.8], EdgeForm[{GrayLevel[0], Opacity[
        0.7]}], {DiskBox[{0., 1.}, 0.02261146496815286], 
         InsetBox["1", 
          Offset[{2, 2}, {0.02261146496815286, 1.0226114649681528}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.40673664307580015, 0.9135454576426009}, 
          0.02261146496815286], 
         InsetBox["3", 
          Offset[{2, 2}, {-0.3841251781076473, 0.9361569226107538}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.20791169081775931, 0.9781476007338057}, 
          0.02261146496815286], 
         InsetBox["2", 
          Offset[{2, 2}, {-0.18530022584960645, 1.0007590657019585}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.9945218953682733, -0.10452846326765346}, 
          0.02261146496815286], 
         InsetBox["9", 
          Offset[{2, 2}, {-0.9719104304001205, -0.0819169982995006}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.7431448254773942, 0.6691306063588582}, 
          0.02261146496815286], 
         InsetBox["27", 
          Offset[{2, 2}, {0.765756290445547, 0.691742071327011}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.5877852522924731, 0.8090169943749475}, 
          0.02261146496815286], 
         InsetBox["4", 
          Offset[{2, 2}, {-0.5651737873243203, 0.8316284593431003}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.5877852522924731, -0.8090169943749475}, 
          0.02261146496815286], 
         InsetBox["19", 
          Offset[{2, 2}, {0.6103967172606259, -0.7864055294067946}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.7431448254773942, 0.6691306063588582}, 
          0.02261146496815286], 
         InsetBox["5", 
          Offset[{2, 2}, {-0.7205333605092414, 0.691742071327011}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.8660254037844386, 0.5}, 0.02261146496815286], 
         InsetBox["26", 
          Offset[{2, 2}, {0.8886368687525914, 0.5226114649681528}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.8660254037844386, 0.5}, 0.02261146496815286], 
         InsetBox["6", 
          Offset[{2, 2}, {-0.8434139388162858, 0.5226114649681528}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {DiskBox[{0., -1.}, 0.02261146496815286], 
         InsetBox["16", 
          Offset[{2, 2}, {0.02261146496815286, -0.9773885350318472}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.9510565162951535, 0.30901699437494745}, 
          0.02261146496815286], 
         InsetBox["7", 
          Offset[{2, 2}, {-0.9284450513270006, 0.3316284593431003}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.20791169081775931, -0.9781476007338057}, 
          0.02261146496815286], 
         InsetBox["17", 
          Offset[{2, 2}, {0.23052315578591218, -0.9555361357656529}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.9945218953682733, 0.10452846326765346}, 
          0.02261146496815286], 
         InsetBox["8", 
          Offset[{2, 2}, {-0.9719104304001205, 0.12713992823580633}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.7431448254773942, -0.6691306063588582}, 
          0.02261146496815286], 
         InsetBox["20", 
          Offset[{2, 2}, {0.765756290445547, -0.6465191413907054}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.40673664307580015, 0.9135454576426009}, 
          0.02261146496815286], 
         InsetBox["29", 
          Offset[{2, 2}, {0.429348108043953, 0.9361569226107538}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.9510565162951535, -0.30901699437494745}, 
          0.02261146496815286], 
         InsetBox["10", 
          Offset[{2, 2}, {-0.9284450513270006, -0.2864055294067946}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.9510565162951535, 0.30901699437494745}, 
          0.02261146496815286], 
         InsetBox["25", 
          Offset[{2, 2}, {0.9736679812633064, 0.3316284593431003}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.8660254037844386, -0.5}, 0.02261146496815286], 
         InsetBox["11", 
          Offset[{2, 2}, {-0.8434139388162858, -0.47738853503184714}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.5877852522924731, -0.8090169943749475}, 
          0.02261146496815286], 
         InsetBox["13", 
          Offset[{2, 2}, {-0.5651737873243203, -0.7864055294067946}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.7431448254773942, -0.6691306063588582}, 
          0.02261146496815286], 
         InsetBox["12", 
          Offset[{2, 2}, {-0.7205333605092414, -0.6465191413907054}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.9945218953682733, 0.10452846326765346}, 
          0.02261146496815286], 
         InsetBox["24", 
          Offset[{2, 2}, {1.017133360336426, 0.12713992823580633}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.40673664307580015, -0.9135454576426009}, 
          0.02261146496815286], 
         InsetBox["14", 
          Offset[{2, 2}, {-0.3841251781076473, -0.890933992674448}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{-0.20791169081775931, -0.9781476007338057}, 
          0.02261146496815286], 
         InsetBox["15", 
          Offset[{2, 2}, {-0.18530022584960645, -0.9555361357656529}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.20791169081775931, 0.9781476007338057}, 
          0.02261146496815286], 
         InsetBox["30", 
          Offset[{2, 2}, {0.23052315578591218, 1.0007590657019585}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.5877852522924731, 0.8090169943749475}, 
          0.02261146496815286], 
         InsetBox["28", 
          Offset[{2, 2}, {0.6103967172606259, 0.8316284593431003}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.9510565162951535, -0.30901699437494745}, 
          0.02261146496815286], 
         InsetBox["22", 
          Offset[{2, 2}, {0.9736679812633064, -0.2864055294067946}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.40673664307580015, -0.9135454576426009}, 
          0.02261146496815286], 
         InsetBox["18", 
          Offset[{2, 2}, {0.429348108043953, -0.890933992674448}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.8660254037844386, -0.5}, 0.02261146496815286], 
         InsetBox["21", 
          Offset[{2, 2}, {0.8886368687525914, -0.47738853503184714}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}, {
         DiskBox[{0.9945218953682733, -0.10452846326765346}, 
          0.02261146496815286], 
         InsetBox["23", 
          Offset[{2, 2}, {1.017133360336426, -0.0819169982995006}], 
          ImageScaled[{0, 0}],
          BaseStyle->"Graphics"]}}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FormatType->TraditionalForm,
  FrameTicks->None,
  ImageSize->{361.3333333333334, Automatic}]], "Output",
 CellChangeTimes->{
  3.872969551076228*^9, 3.872969650568717*^9, {3.872970438991396*^9, 
   3.8729704676090508`*^9}, {3.872970557879944*^9, 3.87297065280501*^9}, {
   3.872970737690297*^9, 3.8729707633852887`*^9}, {3.872970843647419*^9, 
   3.872970876276375*^9}, {3.872971102293299*^9, 3.8729711074522333`*^9}, 
   3.87297163848034*^9, {3.87297167809237*^9, 3.8729716944662557`*^9}, {
   3.8729719287865205`*^9, 3.8729719724133368`*^9}, 3.8729721527687187`*^9, 
   3.872972394633364*^9, 3.8733273592403545`*^9, 3.874847969981101*^9, 
   3.874848018798031*^9, 3.8748480837909255`*^9, 3.874949682882019*^9, 
   3.875101693927483*^9, 3.8751035547129602`*^9, 3.875103595788478*^9, {
   3.875103674978295*^9, 3.8751037035931044`*^9}},
 CellLabel->"Out[91]=",ExpressionUUID->"c1f5dd73-6596-48b5-bd06-8020930c5f2b"]
}, Open  ]],

Cell["Highlight cyclic closed loop:", "Text",
 CellChangeTimes->{{3.8751019498300543`*^9, 
  3.875101965244508*^9}},ExpressionUUID->"f52db631-0af6-437c-8cfa-\
117e732b2173"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"Manipulate", "[", "\[IndentingNewLine]", 
  RowBox[{
   RowBox[{"HighlightGraph", "[", 
    RowBox[{"g", ",", 
     RowBox[{"Style", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"Subgraph", "[", 
        RowBox[{"g", ",", "sg"}], "]"}], "\[IndentingNewLine]", ",", 
       RowBox[{"Directive", "[", 
        RowBox[{
         RowBox[{"Hue", "[", "0.7", "]"}], ",", 
         RowBox[{"Opacity", "[", "1", "]"}]}], "]"}]}], "]"}]}], "]"}], ",", 
   RowBox[{"{", 
    RowBox[{"sg", ",", "components"}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"ControlPlacement", "->", "Top"}], ",", 
   RowBox[{"SaveDefinitions", "->", "True"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8729711121979675`*^9, 3.8729711207461033`*^9}, 
   3.872971366114817*^9, {3.87297143336913*^9, 3.8729714335454483`*^9}, {
   3.8729715056338778`*^9, 3.8729715418817883`*^9}, {3.8729715744720836`*^9, 
   3.8729716031448164`*^9}, {3.87297197620835*^9, 3.872972001224919*^9}, {
   3.8729720633979597`*^9, 3.872972147622128*^9}, {3.8729721801027603`*^9, 
   3.872972187736987*^9}, {3.8729723721917105`*^9, 3.8729723775995846`*^9}, {
   3.8729724154779*^9, 3.872972444861492*^9}, {3.874847938069778*^9, 
   3.8748479478625493`*^9}},
 CellLabel->"In[92]:=",ExpressionUUID->"642b2005-1edf-4ae6-b772-c6c4df036f91"],

Cell[BoxData[
 TagBox[
  StyleBox[
   DynamicModuleBox[{$CellContext`sg$$ = {18, 26, 4, 5, 19, 20, 12, 8}, 
    Typeset`show$$ = True, Typeset`bookmarkList$$ = {}, 
    Typeset`bookmarkMode$$ = "Menu", Typeset`animator$$, Typeset`animvar$$ = 
    1, Typeset`name$$ = "\"untitled\"", Typeset`specs$$ = {{
      Hold[$CellContext`sg$$], {{23, 27, 11, 3, 13, 1, 24, 30, 2, 15, 9, 21, 
       29}, {6, 25, 16, 10, 28, 14, 7, 22, 17}, {18, 26, 4, 5, 19, 20, 12, 
       8}}}}, Typeset`size$$ = {
    396.00000000000006`, {196., 201.75533127810132`}}, Typeset`update$$ = 0, 
    Typeset`initDone$$, Typeset`skipInitDone$$ = False}, 
    DynamicBox[Manipulate`ManipulateBoxes[
     1, StandardForm, 
      "Variables" :> {$CellContext`sg$$ = {23, 27, 11, 3, 13, 1, 24, 30, 2, 
         15, 9, 21, 29}}, "ControllerVariables" :> {}, 
      "OtherVariables" :> {
       Typeset`show$$, Typeset`bookmarkList$$, Typeset`bookmarkMode$$, 
        Typeset`animator$$, Typeset`animvar$$, Typeset`name$$, 
        Typeset`specs$$, Typeset`size$$, Typeset`update$$, Typeset`initDone$$,
         Typeset`skipInitDone$$}, "Body" :> HighlightGraph[$CellContext`g, 
        Style[
         Subgraph[$CellContext`g, $CellContext`sg$$], 
         Directive[
          Hue[0.7], 
          Opacity[1]]]], 
      "Specifications" :> {{$CellContext`sg$$, {{23, 27, 11, 3, 13, 1, 24, 30,
           2, 15, 9, 21, 29}, {6, 25, 16, 10, 28, 14, 7, 22, 17}, {18, 26, 4, 
          5, 19, 20, 12, 8}}}}, "Options" :> {ControlPlacement -> Top}, 
      "DefaultOptions" :> {}],
     ImageSizeCache->{457., {243.84743641130626`, 250.15256358869374`}},
     SingleEvaluation->True],
    Deinitialization:>None,
    DynamicModuleValues:>{},
    Initialization:>({$CellContext`g = 
       Graph[{1, 3, 2, 9, 27, 4, 19, 5, 26, 6, 16, 7, 17, 8, 20, 29, 10, 25, 
         11, 13, 12, 24, 14, 15, 30, 28, 22, 18, 21, 23}, {
          DirectedEdge[1, 3], 
          DirectedEdge[2, 9], 
          DirectedEdge[3, 27], 
          DirectedEdge[4, 19], 
          DirectedEdge[5, 26], 
          DirectedEdge[6, 16], 
          DirectedEdge[7, 17], 
          DirectedEdge[8, 20], 
          DirectedEdge[9, 29], 
          DirectedEdge[10, 25], 
          DirectedEdge[11, 13], 
          DirectedEdge[12, 8], 
          DirectedEdge[13, 24], 
          DirectedEdge[14, 10], 
          DirectedEdge[15, 30], 
          DirectedEdge[16, 28], 
          DirectedEdge[17, 22], 
          DirectedEdge[18, 4], 
          DirectedEdge[19, 12], 
          DirectedEdge[20, 5], 
          DirectedEdge[21, 15], 
          DirectedEdge[22, 14], 
          DirectedEdge[23, 11], 
          DirectedEdge[24, 2], 
          DirectedEdge[25, 6], 
          DirectedEdge[26, 18], 
          DirectedEdge[27, 23], 
          DirectedEdge[28, 7], 
          DirectedEdge[29, 21], 
          DirectedEdge[30, 1]}, {
         EdgeShapeFunction -> {$CellContext`HyperbolicLineEdge}, EdgeStyle -> {
            Opacity[0.3]}, VertexLabels -> {"Name"}, 
          VertexCoordinates -> {{0, 1}, {-Sin[(2 Pi)/15], 
             Cos[(2 Pi)/15]}, {-Sin[Pi/15], 
             Cos[Pi/15]}, {-Cos[Pi/30], -Sin[Pi/30]}, {
             Cos[(7 Pi)/30], 
             Sin[(7 Pi)/30]}, {-Sqrt[5/8 - Sqrt[5]/8], (1 + Sqrt[5])/4}, {
             Sqrt[5/8 - Sqrt[5]/8], (-1 - Sqrt[5])/4}, {-Cos[(7 Pi)/30], 
             Sin[(7 Pi)/30]}, {Sqrt[3]/2, 1/2}, {((-1)/2) Sqrt[3], 1/2}, {
            0, -1}, {-Sqrt[5/8 + Sqrt[5]/8], (-1 + Sqrt[5])/4}, {
             Sin[Pi/15], -Cos[Pi/15]}, {-Cos[Pi/30], 
             Sin[Pi/30]}, {
             Cos[(7 Pi)/30], -Sin[(7 Pi)/30]}, {
             Sin[(2 Pi)/15], 
             Cos[(2 Pi)/15]}, {-Sqrt[5/8 + Sqrt[5]/8], (1 - Sqrt[5])/4}, {
             Sqrt[5/8 + Sqrt[5]/8], (-1 + Sqrt[5])/4}, {((-1)/2) 
             Sqrt[3], (-1)/2}, {-Sqrt[5/8 - Sqrt[5]/8], (-1 - Sqrt[5])/4}, {-
             Cos[(7 Pi)/30], -Sin[(7 Pi)/30]}, {
             Cos[Pi/30], 
             Sin[Pi/30]}, {-Sin[(2 Pi)/15], -Cos[(2 Pi)/15]}, {-Sin[Pi/15], -
             Cos[Pi/15]}, {
             Sin[Pi/15], 
             Cos[Pi/15]}, {
             Sqrt[5/8 - Sqrt[5]/8], (1 + Sqrt[5])/4}, {
             Sqrt[5/8 + Sqrt[5]/8], (1 - Sqrt[5])/4}, {
             Sin[(2 Pi)/15], -Cos[(2 Pi)/15]}, {Sqrt[3]/2, (-1)/2}, {
             Cos[Pi/30], -Sin[Pi/30]}}}], $CellContext`sg$$ = 
       Graph[{23, 27, 11, 3, 13, 1, 24, 30, 2, 15, 9, 21, 29}, {
          DirectedEdge[27, 23], 
          DirectedEdge[23, 11], 
          DirectedEdge[3, 27], 
          DirectedEdge[11, 13], 
          DirectedEdge[1, 3], 
          DirectedEdge[13, 24], 
          DirectedEdge[30, 1], 
          DirectedEdge[24, 2], 
          DirectedEdge[15, 30], 
          DirectedEdge[2, 9], 
          DirectedEdge[21, 15], 
          DirectedEdge[29, 21], 
          DirectedEdge[9, 29]}, {VertexLabels -> {"Name"}}]}; 
     Typeset`initDone$$ = True),
    SynchronousInitialization->True,
    UndoTrackedVariables:>{Typeset`show$$, Typeset`bookmarkMode$$},
    UnsavedVariables:>{Typeset`initDone$$},
    UntrackedVariables:>{Typeset`size$$}], "Manipulate",
   Deployed->True,
   StripOnInput->False],
  Manipulate`InterpretManipulate[1]]], "Output",
 CellChangeTimes->{
  3.874848090199685*^9, 3.874949682964468*^9, 3.87510355475618*^9, 
   3.875103595827876*^9, {3.8751036750202513`*^9, 3.8751037036352196`*^9}},
 CellLabel->"Out[92]=",ExpressionUUID->"30b7e1e7-8eef-485a-b3a0-9c7b989fc2c2"]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Classification of other roots by cyclic length", "Subsection",
 CellChangeTimes->{{3.8751024924564056`*^9, 3.8751025040770845`*^9}, {
  3.8751027323021297`*^9, 
  3.8751027549619875`*^9}},ExpressionUUID->"ea4688d3-9dfb-40de-9a2c-\
79d3cdf270fa"],

Cell["\<\
cyclic length is monotonically determined  by calculating the number of 1\
\[CloseCurlyQuote]s in the list\
\>", "Text",
 CellChangeTimes->{{3.8751041498696585`*^9, 
  3.8751042002005343`*^9}},ExpressionUUID->"7742dc90-5f8d-4f75-bb53-\
e7eeebe45a6a"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"With", "[", 
  RowBox[{
   RowBox[{"{", 
    RowBox[{"data", "=", 
     RowBox[{"GroupBy", "[", 
      RowBox[{
       RowBox[{"Range", "[", "30", "]"}], ",", "\[IndentingNewLine]", 
       RowBox[{"Function", "[", 
        RowBox[{
         RowBox[{"{", "num", "}"}], ",", 
         RowBox[{
          RowBox[{"Count", "[", "1", "]"}], "@", 
          RowBox[{"Array", "[", 
           RowBox[{
            RowBox[{
             RowBox[{"PowerMod", "[", 
              RowBox[{"num", ",", "#", ",", "31"}], "]"}], "&"}], ",", "30"}],
            "]"}]}]}], "]"}]}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
   RowBox[{"Column", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"SortBy", "[", "First", "]"}], "@*", "Normal"}], "@", "data"}], 
    "]"}]}], "\[IndentingNewLine]", "]"}]], "Input",
 CellChangeTimes->{{3.875102786788497*^9, 3.8751028420684185`*^9}, {
  3.8751028778226957`*^9, 3.8751028813356752`*^9}, {3.87510292981489*^9, 
  3.875102968264989*^9}, {3.8751031698789444`*^9, 3.875103265026802*^9}, {
  3.8751033237859755`*^9, 3.875103397201401*^9}, {3.875103444014408*^9, 
  3.8751034576964164`*^9}, {3.8751037712840424`*^9, 3.875103782655429*^9}, {
  3.8751038130741444`*^9, 3.8751040120340204`*^9}},
 CellLabel->"In[99]:=",ExpressionUUID->"8f594b7c-0f84-4313-bd13-acf5d0f0d8e9"],

Cell[BoxData[
 TagBox[GridBox[{
    {
     RowBox[{"1", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "3", ",", "11", ",", "12", ",", "13", ",", "17", ",", "21", ",", "22", 
        ",", "24"}], "}"}]}]},
    {
     RowBox[{"2", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{
       "7", ",", "9", ",", "10", ",", "14", ",", "18", ",", "19", ",", "20", 
        ",", "28"}], "}"}]}]},
    {
     RowBox[{"3", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"15", ",", "23", ",", "27", ",", "29"}], "}"}]}]},
    {
     RowBox[{"5", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"6", ",", "26"}], "}"}]}]},
    {
     RowBox[{"6", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"2", ",", "4", ",", "8", ",", "16"}], "}"}]}]},
    {
     RowBox[{"10", "\[Rule]", 
      RowBox[{"{", 
       RowBox[{"5", ",", "25"}], "}"}]}]},
    {
     RowBox[{"15", "\[Rule]", 
      RowBox[{"{", "30", "}"}]}]},
    {
     RowBox[{"30", "\[Rule]", 
      RowBox[{"{", "1", "}"}]}]}
   },
   DefaultBaseStyle->"Column",
   GridBoxAlignment->{"Columns" -> {{Left}}},
   GridBoxItemSize->{"Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
  "Column"]], "Output",
 CellChangeTimes->{{3.87510333626277*^9, 3.875103397609596*^9}, {
   3.8751034453665934`*^9, 3.875103458101384*^9}, 3.8751038203750515`*^9, {
   3.875103908594324*^9, 3.875104012886877*^9}},
 CellLabel->"Out[99]=",ExpressionUUID->"3bb211c6-7228-488f-a58f-75469e9c8f0f"]
}, Open  ]]
}, Open  ]]
}, Open  ]],

Cell[CellGroupData[{

Cell["Utility", "Section",
 InitializationGroup->True,
 CellChangeTimes->{{3.872972558269484*^9, 
  3.872972559533928*^9}},ExpressionUUID->"8a735766-d972-4e3d-871a-\
a3e651ffe26a"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"a", " ", "modified", " ", "version", " ", "of", " ", 
    RowBox[{"https", ":"}]}], "//", 
   RowBox[{
    RowBox[{
     RowBox[{
      RowBox[{"mathematica", ".", "stackexchange", ".", "com"}], "/", "a"}], 
     "/", "65256"}], "/", "10104"}]}], "*)"}]], "Input",
 CellChangeTimes->{{3.875102602778325*^9, 3.875102604604189*^9}, {
  3.875102636329699*^9, 
  3.87510266438479*^9}},ExpressionUUID->"54f090ef-c98f-45a1-b935-\
22f6a2bb8bac"],

Cell[BoxData[
 RowBox[{"Clear", "[", 
  RowBox[{"HyperbolicLineEdge", ",", "iHyperbolicLine"}], "]"}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.8684016138542747`*^9, 3.8684016416877403`*^9}, 
   3.8684026603801126`*^9, {3.8684034133555884`*^9, 3.868403442151926*^9}},
 CellLabel->"In[18]:=",ExpressionUUID->"b9b00eed-b3f8-44c5-9be7-42078b007321"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{
    RowBox[{"Options", "[", "HyperbolicLineEdge", "]"}], "=", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"\"\<ArrowHeadSizes\>\"", "->", "0.04"}], ",", "\"\<Line\>\""}],
      "}"}]}], ";"}], "*)"}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.8684026015652504`*^9, 3.8684026032038784`*^9}, 
   3.868403008231345*^9, {3.8684031902154784`*^9, 3.8684032431509247`*^9}, 
   3.8684034014088807`*^9},
 CellLabel->"In[19]:=",ExpressionUUID->"734c451c-08dc-42e3-8f32-bce9bd1ff51d"],

Cell[BoxData[
 RowBox[{
  RowBox[{"HyperbolicLineEdge", "[", 
   RowBox[{"pts_List", ",", "e_"}], "]"}], ":=", 
  RowBox[{"iHyperbolicLine", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"First", "[", "pts", "]"}], ",", 
     RowBox[{"Last", "[", "pts", "]"}]}], "}"}], "]"}]}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.8683923820766*^9, 3.868392421653064*^9}, {
   3.8683926196467123`*^9, 3.868392674767703*^9}, {3.868392715885401*^9, 
   3.868392717244933*^9}, {3.8683933611684484`*^9, 3.868393375846316*^9}, {
   3.8683967948995523`*^9, 3.868396810225929*^9}, {3.8683977742692037`*^9, 
   3.8683977762410297`*^9}, {3.8684011738847456`*^9, 3.868401184594337*^9}, 
   3.868402610635621*^9, {3.868402665275066*^9, 3.86840274952721*^9}, 
   3.8684028485520463`*^9, {3.8684029070265107`*^9, 3.8684029126941442`*^9}, {
   3.8684030130191774`*^9, 3.8684030403842325`*^9}, {3.8684031409463406`*^9, 
   3.868403204032775*^9}, {3.868403396701056*^9, 3.868403396866769*^9}, {
   3.868403464747278*^9, 3.8684034652972155`*^9}},
 CellLabel->"In[20]:=",ExpressionUUID->"62062fe6-5073-432b-8c1d-90c35e6eb792"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
   RowBox[{"Options", "[", "iHyperbolicLine", "]"}], "=", 
   RowBox[{"OptionsPattern", "[", "HyperbolicLineEdge", "]"}]}], 
  "*)"}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.868402770068216*^9, 3.8684028114882135`*^9}, 
   3.8684034065114803`*^9},
 CellLabel->"In[21]:=",ExpressionUUID->"10f0c5e8-5341-4091-80b5-48820e565355"],

Cell[BoxData[
 RowBox[{
  RowBox[{"iHyperbolicLine", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Px_", ",", "Py_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Qx_", ",", "Qy_"}], "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"oc", ",", "oa"}], "}"}], ",", 
    RowBox[{"If", "[", 
     RowBox[{
      RowBox[{
       RowBox[{"N", "[", 
        RowBox[{"Chop", "[", 
         RowBox[{
          RowBox[{"Px", " ", "Qy"}], "-", 
          RowBox[{"Py", " ", "Qx"}]}], "]"}], "]"}], "=!=", "0."}], ",", 
      "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{"oa", "=", 
        RowBox[{"orthoAngles", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Px", ",", "Py"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"Qx", ",", "Qy"}], "}"}]}], "}"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"oc", "=", 
        RowBox[{"orthoCentre", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Px", ",", "Py"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"Qx", ",", "Qy"}], "}"}]}], "}"}], "]"}]}], ";", 
       "\[IndentingNewLine]", 
       RowBox[{"{", 
        RowBox[{
         RowBox[{"Arrowheads", "[", 
          RowBox[{"If", "[", 
           RowBox[{
            RowBox[{
             RowBox[{
              RowBox[{"oa", "[", 
               RowBox[{"[", "2", "]"}], "]"}], "-", 
              RowBox[{"oa", "[", 
               RowBox[{"[", "1", "]"}], "]"}]}], ">", "0"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", "0.022", ",", "0.022", ",", "0"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"0", ",", 
              RowBox[{"-", "0.022"}], ",", 
              RowBox[{"-", "0.022"}], ",", "0"}], "}"}]}], "]"}], "]"}], ",", 
         "\[IndentingNewLine]", 
         RowBox[{"Thickness", "[", "0.003", "]"}], ",", "\[IndentingNewLine]", 
         RowBox[{"Arrow", "@", 
          RowBox[{
           InterpretationBox[
            TagBox[
             DynamicModuleBox[{Typeset`open = False}, 
              FrameBox[
               PaneSelectorBox[{False->GridBox[{
                  {
                   PaneBox[GridBox[{
                    {
                    StyleBox[
                    StyleBox[
                    AdjustmentBox["\<\"[\[FilledSmallSquare]]\"\>",
                    BoxBaselineShift->-0.25,
                    BoxMargins->{{0, 0}, {-1, -1}}], "ResourceFunctionIcon",
                    
                    FontColor->RGBColor[
                    0.8745098039215686, 0.2784313725490196, 
                    0.03137254901960784]],
                    ShowStringCharacters->False,
                    FontFamily->"Source Sans Pro Black",
                    FontSize->0.6538461538461539 Inherited,
                    FontWeight->"Heavy",
                    PrivateFontOptions->{"OperatorSubstitution"->False}], 
                    StyleBox[
                    RowBox[{
                    StyleBox["SplineCircle", "ResourceFunctionLabel"], " "}],
                    ShowAutoStyles->False,
                    ShowStringCharacters->False,
                    FontSize->Rational[12, 13] Inherited,
                    FontColor->GrayLevel[0.1]]}
                    },
                    GridBoxSpacings->{"Columns" -> {{0.25}}}],
                    Alignment->Left,
                    
                    BaseStyle->{
                    LineSpacing -> {0, 0}, LineBreakWithin -> False},
                    BaselinePosition->Baseline,
                    FrameMargins->{{3, 0}, {0, 0}}], 
                   ItemBox[
                    PaneBox[
                    TogglerBox[Dynamic[Typeset`open], {True->
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "FEBitmaps", "IconizeCloser"],
                    ImageSizeCache->{11., {2., 9.}}], False->
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "FEBitmaps", "IconizeOpener"],
                    ImageSizeCache->{11., {2., 9.}}]},
                    Appearance->None,
                    BaselinePosition->Baseline,
                    ContentPadding->False,
                    FrameMargins->0],
                    Alignment->Left,
                    BaselinePosition->Baseline,
                    FrameMargins->{{1, 1}, {0, 0}}],
                    Frame->{{
                    RGBColor[
                    0.8313725490196079, 0.8470588235294118, 
                    0.8509803921568627, 0.5], False}, {False, False}}]}
                 },
                 BaselinePosition->{1, 1},
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                 GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0}}}], 
                True->GridBox[{
                  {GridBox[{
                    {
                    PaneBox[GridBox[{
                    {
                    StyleBox[
                    StyleBox[
                    AdjustmentBox["\<\"[\[FilledSmallSquare]]\"\>",
                    BoxBaselineShift->-0.25,
                    BoxMargins->{{0, 0}, {-1, -1}}], "ResourceFunctionIcon",
                    
                    FontColor->RGBColor[
                    0.8745098039215686, 0.2784313725490196, 
                    0.03137254901960784]],
                    ShowStringCharacters->False,
                    FontFamily->"Source Sans Pro Black",
                    FontSize->0.6538461538461539 Inherited,
                    FontWeight->"Heavy",
                    PrivateFontOptions->{"OperatorSubstitution"->False}], 
                    StyleBox[
                    RowBox[{
                    StyleBox["SplineCircle", "ResourceFunctionLabel"], " "}],
                    ShowAutoStyles->False,
                    ShowStringCharacters->False,
                    FontSize->Rational[12, 13] Inherited,
                    FontColor->GrayLevel[0.1]]}
                    },
                    GridBoxSpacings->{"Columns" -> {{0.25}}}],
                    Alignment->Left,
                    
                    BaseStyle->{
                    LineSpacing -> {0, 0}, LineBreakWithin -> False},
                    BaselinePosition->Baseline,
                    FrameMargins->{{3, 0}, {0, 0}}], 
                    ItemBox[
                    PaneBox[
                    TogglerBox[Dynamic[Typeset`open], {True->
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "FEBitmaps", "IconizeCloser"],
                    ImageSizeCache->{11., {2., 9.}}], False->
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "FEBitmaps", "IconizeOpener"],
                    ImageSizeCache->{11., {2., 9.}}]},
                    Appearance->None,
                    BaselinePosition->Baseline,
                    ContentPadding->False,
                    FrameMargins->0],
                    Alignment->Left,
                    BaselinePosition->Baseline,
                    FrameMargins->{{1, 1}, {0, 0}}],
                    Frame->{{
                    RGBColor[
                    0.8313725490196079, 0.8470588235294118, 
                    0.8509803921568627, 0.5], False}, {False, False}}]}
                    },
                    BaselinePosition->{1, 1},
                    
                    GridBoxAlignment->{
                    "Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                    GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0}}}]},
                  {
                   StyleBox[
                    PaneBox[GridBox[{
                    {
                    RowBox[{
                    TagBox["\<\"Version (latest): \"\>",
                    "IconizedLabel"], " ", 
                    TagBox["\<\"2.0.0\"\>",
                    "IconizedItem"]}]},
                    {
                    TagBox[
                    
                    TemplateBox[{
                    "\"Documentation \[RightGuillemet]\"", 
                    "https://resources.wolframcloud.com/FunctionRepository/\
resources/d68e4122-d684-41c5-9855-c3558aefe757/"},
                    "HyperlinkURL"],
                    "IconizedItem"]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                    Alignment->Left,
                    BaselinePosition->Baseline,
                    FrameMargins->{{5, 4}, {0, 4}}], "DialogStyle",
                    FontFamily->"Roboto",
                    FontSize->11]}
                 },
                 BaselinePosition->{1, 1},
                 
                 GridBoxAlignment->{
                  "Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
                 GridBoxDividers->{"Columns" -> {{None}}, "Rows" -> {False, {
                    GrayLevel[0.8]}, False}},
                 
                 GridBoxItemSize->{
                  "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]}, 
                Dynamic[Typeset`open],
                BaselinePosition->Baseline,
                ImageSize->Automatic],
               
               Background->RGBColor[
                0.9686274509803922, 0.9764705882352941, 0.984313725490196],
               BaselinePosition->Baseline,
               DefaultBaseStyle->{},
               FrameMargins->{{0, 0}, {1, 0}},
               
               FrameStyle->RGBColor[
                0.8313725490196079, 0.8470588235294118, 0.8509803921568627],
               RoundingRadius->4]],
             {"FunctionResourceBox", 
              RGBColor[
              0.8745098039215686, 0.2784313725490196, 0.03137254901960784], 
              "SplineCircle"},
             TagBoxNote->"FunctionResourceBox"],
            ResourceFunction[
             
             ResourceObject[<|
              "Name" -> "SplineCircle", "ShortName" -> "SplineCircle", "UUID" -> 
               "d68e4122-d684-41c5-9855-c3558aefe757", "ResourceType" -> 
               "Function", "Version" -> "2.0.0", "Description" -> 
               "Generate a BSplineCurve primitive representing a circle", 
               "RepositoryLocation" -> 
               URL["https://www.wolframcloud.com/obj/resourcesystem/api/1.0"],
                "SymbolName" -> 
               "FunctionRepository`$d59af2841aa04fd3a4b27cbe047cff23`\
SplineCircle", "FunctionLocation" -> 
               CloudObject[
                "https://www.wolframcloud.com/obj/deae10bf-ade2-433c-ab22-\
c79f3a0004bb"]|>, ResourceSystemBase -> Automatic]],
            Selectable->False], "[", 
           RowBox[{"oc", ",", "\[IndentingNewLine]", 
            RowBox[{"OrthoRadius", "[", 
             RowBox[{"{", 
              RowBox[{
               RowBox[{"{", 
                RowBox[{"Px", ",", "Py"}], "}"}], ",", 
               RowBox[{"{", 
                RowBox[{"Qx", ",", "Qy"}], "}"}]}], "}"}], "]"}], ",", 
            "\[IndentingNewLine]", 
            RowBox[{"{", 
             RowBox[{"1", ",", "0"}], "}"}], ",", "oa"}], "]"}]}]}], "}"}]}], 
      ",", "\[IndentingNewLine]", 
      RowBox[{"{", 
       RowBox[{
        RowBox[{"Arrowheads", "[", 
         RowBox[{"{", "0.03", "}"}], "]"}], ",", 
        RowBox[{"Directive", "[", 
         RowBox[{"Thickness", "[", "0.004", "]"}], "]"}], ",", 
        RowBox[{"Arrow", "[", 
         RowBox[{"{", 
          RowBox[{
           RowBox[{"{", 
            RowBox[{"Px", ",", "Py"}], "}"}], ",", 
           RowBox[{"{", 
            RowBox[{"Qx", ",", "Qy"}], "}"}]}], "}"}], "]"}]}], "}"}]}], 
     "]"}]}], "]"}]}]], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.8683922572127895`*^9, 3.8683922572137904`*^9}, 
   3.8683924042567887`*^9, {3.8683928200281205`*^9, 3.868392820882304*^9}, {
   3.8683932796054335`*^9, 3.8683932804360247`*^9}, {3.8683936544123106`*^9, 
   3.8683937231718535`*^9}, {3.868393789956683*^9, 3.8683938219345517`*^9}, {
   3.868393870067153*^9, 3.868393947537585*^9}, 3.8683953487309885`*^9, {
   3.8683956946428776`*^9, 3.8683958134078217`*^9}, {3.8683960708481946`*^9, 
   3.868396134299759*^9}, {3.868396200214862*^9, 3.8683963291850758`*^9}, {
   3.8683964250697584`*^9, 3.868396468221055*^9}, {3.8683972697200584`*^9, 
   3.8683972746132936`*^9}, {3.868397313038745*^9, 3.868397317504707*^9}, 
   3.868397392917969*^9, 3.8683974467897377`*^9, {3.868397665098175*^9, 
   3.868397759548397*^9}, 3.868398152630967*^9, {3.868399016827548*^9, 
   3.8683990260461864`*^9}, 3.868399132698881*^9, {3.8683991640045443`*^9, 
   3.8683992133888097`*^9}, {3.8683993177792892`*^9, 
   3.8683994090028625`*^9}, {3.8684007175147333`*^9, 3.868400730353114*^9}, {
   3.868402402660165*^9, 3.8684024453249283`*^9}, {3.8684026095782757`*^9, 
   3.8684026813350844`*^9}, 3.868402729825328*^9, {3.86840282411003*^9, 
   3.8684028266250973`*^9}, {3.868402884508695*^9, 3.8684028888963585`*^9}, {
   3.8684032271975374`*^9, 3.8684032319964943`*^9}, 3.8684034101650667`*^9, {
   3.8684050465154066`*^9, 3.8684050485855618`*^9}, {3.868405079897687*^9, 
   3.8684050800325613`*^9}, {3.8697063601695747`*^9, 
   3.8697063789360113`*^9}, {3.8729704280771046`*^9, 
   3.8729704620553102`*^9}, {3.872970539780898*^9, 3.87297064794771*^9}, {
   3.8729707258054867`*^9, 3.8729707598434486`*^9}, {3.8729708392850943`*^9, 
   3.8729708727089634`*^9}, {3.8729719172804375`*^9, 3.872971938955493*^9}},
 CellLabel->"In[22]:=",ExpressionUUID->"af1a93d0-9f6b-4d89-81a2-fcf7c264e5f8"],

Cell[BoxData[{
 RowBox[{
  RowBox[{
   RowBox[{"orthoCentre", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Px_", ",", "Py_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Qx_", ",", "Qy_"}], "}"}]}], "}"}], "]"}], ":=", 
   RowBox[{"With", "[", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"d", "=", 
        RowBox[{
         RowBox[{"2", " ", "Px", " ", "Qy"}], "-", 
         RowBox[{"2", " ", "Py", " ", "Qx"}]}]}], ",", 
       RowBox[{"p", "=", 
        RowBox[{"1", "+", 
         RowBox[{"Px", "^", "2"}]}]}], ",", 
       RowBox[{"q", "=", 
        RowBox[{"1", "+", 
         RowBox[{"Qx", "^", "2"}], "+", 
         RowBox[{"Qy", "^", "2"}]}]}]}], "}"}], ",", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"N", "[", "d", "]"}], "=!=", "0."}], ",", 
       RowBox[{
        RowBox[{"{", 
         RowBox[{
          RowBox[{
           RowBox[{"p", " ", "Qy"}], "+", 
           RowBox[{
            RowBox[{"Py", "^", "2"}], " ", "Qy"}], "-", 
           RowBox[{"Py", " ", "q"}]}], ",", 
          RowBox[{
           RowBox[{
            RowBox[{"-", "p"}], " ", "Qx"}], "-", 
           RowBox[{
            RowBox[{"Py", "^", "2"}], " ", "Qx"}], "+", 
           RowBox[{"Px", " ", "q"}]}]}], "}"}], "/", "d"}], ",", 
       "ComplexInfinity"}], "]"}]}], "]"}]}], "\[IndentingNewLine]"}], "\n", 
 RowBox[{
  RowBox[{
   RowBox[{"OrthoRadius", "[", 
    RowBox[{"{", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"Px_", ",", "Py_"}], "}"}], ",", 
      RowBox[{"{", 
       RowBox[{"Qx_", ",", "Qy_"}], "}"}]}], "}"}], "]"}], ":=", 
   RowBox[{"If", "[", 
    RowBox[{
     RowBox[{
      RowBox[{"N", "[", 
       RowBox[{"Chop", "[", 
        RowBox[{
         RowBox[{"Px", " ", "Qy"}], "-", 
         RowBox[{"Py", " ", "Qx"}]}], "]"}], "]"}], "=!=", "0."}], ",", 
     RowBox[{"Sqrt", "[", 
      RowBox[{
       RowBox[{"Total", "[", 
        RowBox[{
         RowBox[{"orthoCentre", "[", 
          RowBox[{"{", 
           RowBox[{
            RowBox[{"{", 
             RowBox[{"Px", ",", "Py"}], "}"}], ",", 
            RowBox[{"{", 
             RowBox[{"Qx", ",", "Qy"}], "}"}]}], "}"}], "]"}], "^", "2"}], 
        "]"}], "-", "1"}], "]"}], ",", "Infinity"}], "]"}]}], 
  "\[IndentingNewLine]"}], "\[IndentingNewLine]", 
 RowBox[{
  RowBox[{"orthoAngles", "[", 
   RowBox[{"{", 
    RowBox[{
     RowBox[{"{", 
      RowBox[{"Px_", ",", "Py_"}], "}"}], ",", 
     RowBox[{"{", 
      RowBox[{"Qx_", ",", "Qy_"}], "}"}]}], "}"}], "]"}], ":=", 
  RowBox[{"Module", "[", 
   RowBox[{
    RowBox[{"{", 
     RowBox[{"a", ",", "b", ",", 
      RowBox[{"c", "=", 
       RowBox[{"orthoCentre", "[", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"{", 
           RowBox[{"Px", ",", "Py"}], "}"}], ",", 
          RowBox[{"{", 
           RowBox[{"Qx", ",", "Qy"}], "}"}]}], "}"}], "]"}]}], ",", 
      "angleRange"}], "}"}], ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"angleRange", "=", 
      RowBox[{"Mod", "[", 
       RowBox[{
        RowBox[{"{", "\[IndentingNewLine]", 
         RowBox[{
          RowBox[{"N", "[", 
           RowBox[{"Apply", "[", 
            RowBox[{"ArcTan", ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"Px", ",", "Py"}], "}"}], "-", "c"}]}], "]"}], "]"}], 
          ",", "\[IndentingNewLine]", 
          RowBox[{"N", "[", 
           RowBox[{"Apply", "[", 
            RowBox[{"ArcTan", ",", 
             RowBox[{
              RowBox[{"{", 
               RowBox[{"Qx", ",", "Qy"}], "}"}], "-", "c"}]}], "]"}], "]"}]}],
          "}"}], ",", 
        RowBox[{"2", "\[Pi]"}]}], "]"}]}], ";", "\[IndentingNewLine]", 
     RowBox[{"If", "[", 
      RowBox[{
       RowBox[{
        RowBox[{"Abs", "[", 
         RowBox[{
          RowBox[{"angleRange", "[", 
           RowBox[{"[", "2", "]"}], "]"}], "-", 
          RowBox[{"angleRange", "[", 
           RowBox[{"[", "1", "]"}], "]"}]}], "]"}], ">", "\[Pi]"}], ",", 
       RowBox[{"Mod", "[", 
        RowBox[{"angleRange", ",", 
         RowBox[{"2", "\[Pi]"}], ",", 
         RowBox[{"-", "\[Pi]"}]}], "]"}], ",", "angleRange"}], "]"}]}]}], 
   "\[IndentingNewLine]", "]"}]}]}], "Input",
 InitializationGroup->True,
 CellChangeTimes->{{3.868392279902598*^9, 3.868392279904599*^9}, {
   3.868393153286587*^9, 3.868393157794162*^9}, {3.8683931984237466`*^9, 
   3.8683932411389112`*^9}, {3.8683933254067535`*^9, 3.868393329091163*^9}, {
   3.868394187438922*^9, 3.8683942387639875`*^9}, {3.8683948260016537`*^9, 
   3.8683948287471433`*^9}, {3.8683948832349234`*^9, 
   3.8683948870836124`*^9}, {3.86839491746933*^9, 3.8683949392148275`*^9}, {
   3.8683952361563606`*^9, 3.868395237763816*^9}, {3.86839675834313*^9, 
   3.868396759876436*^9}, {3.8683971767303066`*^9, 3.868397191947316*^9}, 
   3.868397962071351*^9, {3.868398067361168*^9, 3.8683981305915008`*^9}, {
   3.8683982110942917`*^9, 3.8683982141124735`*^9}, {3.8683983229229937`*^9, 
   3.8683983327222867`*^9}, {3.868398386230338*^9, 3.8683984073061037`*^9}, {
   3.868398446285143*^9, 3.8683984643257103`*^9}, {3.8683985945038633`*^9, 
   3.868398605743258*^9}, {3.8683986494360547`*^9, 3.868398665732889*^9}, {
   3.868398711483527*^9, 3.868398765430778*^9}, {3.86839881539499*^9, 
   3.8683988196895638`*^9}, 3.8683988537689023`*^9, {3.8683989035267715`*^9, 
   3.868398971122144*^9}, {3.8684006897086835`*^9, 3.8684006912702923`*^9}, {
   3.8684009919910126`*^9, 3.8684010330490456`*^9}, {3.8684010923877983`*^9, 
   3.868401092742652*^9}, {3.868402632143689*^9, 3.8684026460449133`*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"3d15d1b0-7f11-41e6-932c-093f6888b182"]
}, Closed]]
}, Open  ]]
},
WindowSize->{862.6666666666666, 627.6666666666666},
WindowMargins->{{
  Automatic, 192.66666666666674`}, {-0.33333333333337123`, Automatic}},
TaggingRules-><|"TryRealOnly" -> False|>,
Magnification:>1.1 Inherited,
FrontEndVersion->"13.1 for Microsoft Windows (64-bit) (August 22, 2022)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"6db63f26-9afa-43c7-b16d-e6a11f0d53e5"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 431, 6, 174, "Title",ExpressionUUID->"49bd212c-b054-4509-97fc-aad19b77fc5b"],
Cell[1014, 30, 179, 3, 34, "Author",ExpressionUUID->"e18fce9a-8b0a-4f30-8c0c-d34294660e35"],
Cell[CellGroupData[{
Cell[1218, 37, 240, 5, 74, "Section",ExpressionUUID->"77d044b2-4809-4c8e-8bc2-32fc6208deaa"],
Cell[CellGroupData[{
Cell[1483, 46, 200, 2, 45, "WolframAlphaLong",ExpressionUUID->"cb278679-901a-4090-821a-c7ad912ba87c"],
Cell[1686, 50, 36173, 745, 817, "Print",ExpressionUUID->"fed659c7-2a24-4d35-b41e-aa559324c056"]
}, Open  ]],
Cell[37874, 798, 1053, 26, 38, "Text",ExpressionUUID->"962868e8-c2fb-45e6-816e-641782682ade"],
Cell[CellGroupData[{
Cell[38952, 828, 456, 11, 31, "Input",ExpressionUUID->"5a671e7d-1789-42de-baa1-7090d2a87b10"],
Cell[39411, 841, 738, 12, 57, "Output",ExpressionUUID->"0c369cf3-ea32-4546-889f-79659d3e2412"]
}, Open  ]],
Cell[40164, 856, 225, 4, 38, "Text",ExpressionUUID->"291e8784-d271-4796-b158-2cec15e679c6"],
Cell[CellGroupData[{
Cell[40414, 864, 216, 3, 31, "Input",ExpressionUUID->"6c50c435-2981-45ab-82d0-dbf7d4cdab50"],
Cell[40633, 869, 175, 2, 35, "Output",ExpressionUUID->"0b97cddf-cf7e-4409-8dbc-b81f4faa01a5"]
}, Open  ]],
Cell[CellGroupData[{
Cell[40845, 876, 271, 4, 31, "Input",ExpressionUUID->"b62dc8b1-5e37-475f-b08f-4e5b7ab5ac2a"],
Cell[41119, 882, 290, 6, 35, "Output",ExpressionUUID->"60ee45cf-7067-4546-8c9d-4c3acc1bf076"]
}, Open  ]],
Cell[41424, 891, 337, 8, 47, "Text",ExpressionUUID->"dc333991-ad5e-433e-891d-a6f2b5bc528f"],
Cell[CellGroupData[{
Cell[41786, 903, 399, 9, 31, "Input",ExpressionUUID->"0c863a7e-c99f-4b50-a707-93c6809d60e0"],
Cell[42188, 914, 550, 10, 35, "Output",ExpressionUUID->"b0f4d44c-7e2b-4956-a1ec-8ad2769d8bb5"]
}, Open  ]],
Cell[42753, 927, 587, 18, 38, "Text",ExpressionUUID->"2380cca2-06a7-4cdb-8cbc-e10cee9e33a0"],
Cell[CellGroupData[{
Cell[43365, 949, 8547, 206, 40, "Input",ExpressionUUID->"0a10ac70-c3b3-4a3c-a338-36e527a2edb3"],
Cell[51915, 1157, 314, 7, 44, "Output",ExpressionUUID->"9bb28642-2459-4728-baaf-4577d08c551f"]
}, Open  ]],
Cell[CellGroupData[{
Cell[52266, 1169, 187, 3, 59, "Subsection",ExpressionUUID->"1b1cebc2-46a4-4c72-8195-3296be0beae7"],
Cell[52456, 1174, 240, 4, 38, "Text",ExpressionUUID->"a08d58be-22a9-46bf-80b8-995c8efa40e7"],
Cell[CellGroupData[{
Cell[52721, 1182, 455, 11, 31, "Input",ExpressionUUID->"495c5d36-b05d-4edd-92b4-cfbb5e982c5e"],
Cell[53179, 1195, 591, 11, 57, "Output",ExpressionUUID->"8542aa06-d858-4616-ba49-068718a9bfb4"]
}, Open  ]],
Cell[53785, 1209, 277, 6, 31, "Input",ExpressionUUID->"a04efb9a-b3e5-4c04-92e3-d38a4bdd0b46"],
Cell[54065, 1217, 185, 3, 38, "Text",ExpressionUUID->"2d7a3ced-51ce-4c67-a15f-5ff924d87970"],
Cell[CellGroupData[{
Cell[54275, 1224, 519, 9, 31, "Input",ExpressionUUID->"c877bec9-c6ec-4d9e-9907-ba02d68440e9"],
Cell[54797, 1235, 914, 20, 57, "Output",ExpressionUUID->"36d0ca64-877a-4ed2-9bc2-511cdf1de5f3"]
}, Open  ]],
Cell[55726, 1258, 170, 3, 38, "Text",ExpressionUUID->"7f89c926-5238-40f5-ab7a-d040202f652d"],
Cell[CellGroupData[{
Cell[55921, 1265, 590, 13, 31, "Input",ExpressionUUID->"adf2d840-d939-4a14-b7c7-417d2844f9c9"],
Cell[56514, 1280, 4922, 108, 360, "Output",ExpressionUUID->"3009ce6e-1398-4b66-b1f9-165339e72d50"]
}, Open  ]],
Cell[61451, 1391, 240, 6, 38, "Text",ExpressionUUID->"553cd463-5816-4604-9a34-d0a16e3b132e"],
Cell[CellGroupData[{
Cell[61716, 1401, 1286, 28, 94, "Input",ExpressionUUID->"6ace2071-4403-4126-b5df-2474a229716e"],
Cell[63005, 1431, 33655, 662, 417, "Output",ExpressionUUID->"c1f5dd73-6596-48b5-bd06-8020930c5f2b"]
}, Open  ]],
Cell[96675, 2096, 173, 3, 38, "Text",ExpressionUUID->"f52db631-0af6-437c-8cfa-117e732b2173"],
Cell[CellGroupData[{
Cell[96873, 2103, 1319, 25, 115, "Input",ExpressionUUID->"642b2005-1edf-4ae6-b772-c6c4df036f91"],
Cell[98195, 2130, 5421, 119, 514, "Output",ExpressionUUID->"30b7e1e7-8eef-485a-b3a0-9c7b989fc2c2"]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[103665, 2255, 251, 4, 59, "Subsection",ExpressionUUID->"ea4688d3-9dfb-40de-9a2c-79d3cdf270fa"],
Cell[103919, 2261, 260, 6, 38, "Text",ExpressionUUID->"7742dc90-5f8d-4f75-bb53-e7eeebe45a6a"],
Cell[CellGroupData[{
Cell[104204, 2271, 1320, 30, 94, "Input",ExpressionUUID->"8f594b7c-0f84-4313-bd13-acf5d0f0d8e9"],
Cell[105527, 2303, 1429, 44, 164, "Output",ExpressionUUID->"3bb211c6-7228-488f-a58f-75469e9c8f0f"]
}, Open  ]]
}, Open  ]]
}, Open  ]],
Cell[CellGroupData[{
Cell[107017, 2354, 180, 4, 74, "Section",ExpressionUUID->"8a735766-d972-4e3d-871a-a3e651ffe26a",
 InitializationGroup->True],
Cell[107200, 2360, 491, 13, 31, "Input",ExpressionUUID->"54f090ef-c98f-45a1-b935-22f6a2bb8bac"],
Cell[107694, 2375, 365, 6, 31, "Input",ExpressionUUID->"b9b00eed-b3f8-44c5-9be7-42078b007321",
 InitializationGroup->True],
Cell[108062, 2383, 547, 13, 31, "Input",ExpressionUUID->"734c451c-08dc-42e3-8f32-bce9bd1ff51d",
 InitializationGroup->True],
Cell[108612, 2398, 1119, 20, 31, "Input",ExpressionUUID->"62062fe6-5073-432b-8c1d-90c35e6eb792",
 InitializationGroup->True],
Cell[109734, 2420, 388, 9, 31, "Input",ExpressionUUID->"10f0c5e8-5341-4091-80b5-48820e565355",
 InitializationGroup->True],
Cell[110125, 2431, 14094, 319, 237, "Input",ExpressionUUID->"af1a93d0-9f6b-4d89-81a2-fcf7c264e5f8",
 InitializationGroup->True],
Cell[124222, 2752, 5681, 149, 325, "Input",ExpressionUUID->"3d15d1b0-7f11-41e6-932c-093f6888b182",
 InitializationGroup->True]
}, Closed]]
}, Open  ]]
}
]
*)

