(* Content-type: application/vnd.wolfram.mathematica *)

(*** Wolfram Notebook File ***)
(* http://www.wolfram.com/nb *)

(* CreatedBy='Mathematica 13.1' *)

(*CacheID: 234*)
(* Internal cache information:
NotebookFileLineBreakTest
NotebookFileLineBreakTest
NotebookDataPosition[       158,          7]
NotebookDataLength[     88470,       2199]
NotebookOptionsPosition[     85274,       2145]
NotebookOutlinePosition[     85719,       2162]
CellTagsIndexPosition[     85676,       2159]
WindowFrame->Normal*)

(* Beginning of Notebook Content *)
Notebook[{

Cell[CellGroupData[{
Cell["Tree representation for permutation", "Title",
 CellChangeTimes->{{3.8751932219225206`*^9, 3.8751932396294155`*^9}, {
  3.875193646883273*^9, 3.875193678093896*^9}, {3.8751937323566647`*^9, 
  3.875193732491297*^9}, {3.875199000495869*^9, 
  3.8751990100862875`*^9}},ExpressionUUID->"80257d39-3b61-4316-853a-\
55244f205f67"],

Cell[TextData[Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
       20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37,
       38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55,
       56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73,
       74, 75, 76, 77, 78, 79, 80, 81}, {
      Null, {{6, 7}, {6, 8}, {4, 5}, {4, 6}, {18, 19}, {18, 20}, {17, 18}, {
       17, 21}, {16, 17}, {16, 22}, {15, 16}, {15, 23}, {26, 27}, {26, 28}, {
       25, 26}, {25, 29}, {24, 25}, {24, 30}, {14, 15}, {14, 24}, {12, 13}, {
       12, 14}, {31, 32}, {31, 33}, {11, 12}, {11, 31}, {34, 35}, {34, 36}, {
       10, 11}, {10, 34}, {9, 10}, {9, 37}, {3, 4}, {3, 9}, {42, 43}, {42, 
       44}, {48, 49}, {48, 50}, {46, 47}, {46, 48}, {56, 57}, {56, 58}, {55, 
       56}, {55, 59}, {53, 54}, {53, 55}, {51, 52}, {51, 53}, {45, 46}, {45, 
       51}, {41, 42}, {41, 45}, {39, 40}, {39, 41}, {65, 66}, {65, 67}, {63, 
       64}, {63, 65}, {70, 71}, {70, 72}, {73, 74}, {73, 75}, {69, 70}, {69, 
       73}, {68, 69}, {68, 76}, {62, 63}, {62, 68}, {60, 61}, {60, 62}, {38, 
       39}, {38, 60}, {2, 3}, {2, 38}, {78, 79}, {78, 80}, {77, 78}, {77, 
       81}, {1, 2}, {1, 77}}}, {
      GraphLayout -> {
        "LayeredEmbedding", "RootVertex" -> 1, "Orientation" -> Top}, 
       ImagePadding -> 15, 
       VertexShapeFunction -> {
        DataStructure`Visualization`RenderVertex[{
          5 -> Null, 7 -> 46, 8 -> 57, 6 -> 33, 4 -> 27, 13 -> Null, 19 -> 73,
            20 -> Null, 18 -> 45, 21 -> Null, 17 -> 39, 22 -> Null, 16 -> 23, 
           23 -> 23, 15 -> 13, 27 -> 48, 28 -> 87, 26 -> 34, 29 -> 77, 25 -> 
           14, 30 -> 30, 24 -> 12, 14 -> 10, 12 -> 9, 32 -> Null, 33 -> 61, 
           31 -> 52, 11 -> 7, 35 -> Null, 36 -> 98, 34 -> 18, 10 -> 6, 37 -> 
           Null, 9 -> 3, 3 -> 3, 40 -> Null, 43 -> 62, 44 -> Null, 42 -> 21, 
           47 -> Null, 49 -> Null, 50 -> 92, 48 -> 57, 46 -> 35, 52 -> Null, 
           54 -> 49, 57 -> Null, 58 -> 75, 56 -> 52, 59 -> Null, 55 -> 43, 53 -> 
           35, 51 -> 30, 45 -> 19, 41 -> 17, 39 -> 15, 61 -> Null, 64 -> Null,
            66 -> Null, 67 -> 90, 65 -> 47, 63 -> 29, 71 -> Null, 72 -> 94, 
           70 -> 75, 74 -> Null, 75 -> 85, 73 -> 64, 69 -> 24, 76 -> Null, 68 -> 
           12, 62 -> 12, 60 -> 10, 38 -> 8, 2 -> 2, 79 -> 74, 80 -> 73, 78 -> 
           14, 81 -> Null, 77 -> 4, 1 -> 1}, #, #2, 
          DataStructure`Source`BinaryTree`Loader`Private`vertOpts$22655]& }, 
       VertexStyle -> {
         GrayLevel[0]}}]]}, 
    TagBox[GraphicsGroupBox[{
       {Hue[0.6, 0.7, 0.5], Opacity[0.7], Arrowheads[0.], 
        ArrowBox[CompressedData["
1:eJx1lk1oE0EYhlfTpok2qLVNGjXS/OGpelGsFN0porl4aFSUikIRi/hTRaEt
KEgFwSoiCPEiBBHBoAfR+k+VIkIp1ByqVIQiqJWqh1BsexBsRNnN+y37phNY
hm+fd759Z+abmUQPntzZ4TEMo/X/s7D05IZG/Pl0RPVtnT717nFEjY/Ovjl8
pEZ9fzW8Odi8UjF/cWB0TTiSEM76uW317U+fGCrVdNO/73V9GX/e+2nvbM8q
4ay3v1Mw7/R3jWVTwTIe+vMo3vTXr8BZX9m449aX/ITptdrlGj4jnGPoD+Vi
ncndy8r4dsvHb+Hsp7vr8tTZC1UKeubPrPFXC2d9h5V3gUJ+5ra/gHDWwx90
zG0fXsnDeozXfu8r43ZbFM6xe748Gu5R4PPrCyb6MXf7KZrz6yfMilI/XT5w
1tvxe9Movdflc3NHb9BPl8/NnfnAern9Oty9fkWT9WjhV5fPPR5Hj/mFX10+
cK6nStc6+TT15lPu+nHq2T4nFit3vTn8+rfArlRoqbzn82RL+tjw2rt1st+Y
hz/mZvbfjgpn/Ymre+63Hq+V/cZ8SW3v1+rJoHCO0cIvc/s8CAtn/YajGy96
rtXI+Jh/mGofGFxUJ5zz9VjnRUjLMR/grMc4sT7MMY/gHEOPemUOP+Ds50fp
noCe+aXSPQTOMfTIz7zNW3Xlwa/VwjmGHnXPPGPVX4Nw1uP72C+6fOBcjw+7
s5OFiqisO/Pzm/qNty0x4RzDH9abeadV3wnhrIc/zDfzonUfNwjnGHrMN3M7
T1Q4+7HPj7jomY9Z9Z+k88bR2/snptz3jcPRH5z1eV/jmcx0VNabeXakJXN6
XVw454NfHbfPk6Rw/j+Vnhtace9cXPYN8+jg+Pq+gYRw1v+88TLQ/Dkm9aLL
B/4P/PRG6Q==
         "], 0.06846862903512453]}, 
       {GrayLevel[0], EdgeForm[{GrayLevel[0], Opacity[0.7]}], InsetBox[
         FrameBox[
          PaneBox["1",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.329883721411227, 7.426584034358605}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["2",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {4.602934896295177, 6.8077020314953876}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["3",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.0887267596633574, 6.188820028632171}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["27",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0.9283230042948256, 5.569938025768954}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {0.618882002863217, 4.951056022905737}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["33",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.237764005726434, 4.951056022905737}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["46",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0.9283230042948256, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["57",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.5472050071580425, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["3",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {3.2491305150318897, 5.569938025768954}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["6",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.939689513600281, 4.951056022905737}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["7",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.16608701002126, 4.332174020042519}, Center,
          Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["9",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.5472050071580425, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {1.237764005726434, 3.094410014316085}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["10",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.8566460085896512, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["13",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.237764005726434, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["23",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0.9283230042948256, 1.8566460085896512}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["39",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0.618882002863217, 1.2377640057264339}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["45",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0.3094410014316085, 0.6188820028632165}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["73",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0., 0.}, Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {0.618882002863217, 0.}, Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], 
        TagBox[
         InsetBox["\[EmptyCircle]", {0.9283230042948256, 0.6188820028632165}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], 
        TagBox[
         InsetBox["\[EmptyCircle]", {1.237764005726434, 1.2377640057264339}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["23",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.5472050071580425, 1.8566460085896512}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["12",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.475528011452868, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["14",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.16608701002126, 1.8566460085896512}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["34",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.8566460085896512, 1.2377640057264339}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["48",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.5472050071580425, 0.6188820028632165}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["87",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.16608701002126, 0.6188820028632165}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["77",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.475528011452868, 1.2377640057264339}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["30",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.784969012884477, 1.8566460085896512}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["52",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.784969012884477, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {2.475528011452868, 3.094410014316085}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["61",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {3.094410014316085, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["18",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {3.7132920171793025, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {3.4038510157476938, 3.7132920171793025}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["98",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {4.022733018610912, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {3.558571516463498, 4.951056022905737}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["8",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.117143032926997, 6.188820028632171}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["15",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {5.41521752505315, 5.569938025768954}, Center,
          Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {5.105776523621541, 4.951056022905737}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["17",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {5.724658526484759, 4.951056022905737}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["21",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {4.951056022905737, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["62",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {4.641615021474128, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {5.2604970243373455, 3.7132920171793025}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["19",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {6.498261030063779, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["35",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {5.879379027200563, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {5.569938025768954, 3.094410014316085}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["57",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {6.188820028632171, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {5.879379027200563, 2.4755280114528686}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["92",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {6.498261030063779, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["30",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.117143032926997, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {6.807702031495388, 3.094410014316085}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["35",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.426584034358606, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["49",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.117143032926997, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["43",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.736025035790214, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["52",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.426584034358606, 1.8566460085896512}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {7.117143032926997, 1.2377640057264339}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["75",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.736025035790214, 1.2377640057264339}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {8.045466037221821, 1.8566460085896512}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["10",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {8.819068540800844, 5.569938025768954}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {8.509627539369236, 4.951056022905737}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["12",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {9.128509542232452, 4.951056022905737}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["29",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {8.045466037221821, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {7.736025035790214, 3.7132920171793025}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["47",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {8.354907038653431, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {8.045466037221821, 3.094410014316085}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["90",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {8.664348040085038, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["12",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {10.21155304724308, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["24",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {9.902112045811473, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["75",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {9.283230042948256, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {8.973789041516648, 2.4755280114528686}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["94",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {9.592671044379864, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["64",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {10.52099404867469, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {10.21155304724308, 2.4755280114528686}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["85",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {10.8304350501063, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {10.52099404867469, 3.7132920171793025}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["4",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {10.056832546527277, 6.8077020314953876}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["14",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {9.747391545095669, 6.188820028632171}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["74",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {9.43795054366406, 5.569938025768954}, Center,
          Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["73",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {10.056832546527277, 5.569938025768954}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {10.366273547958885, 6.188820028632171}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"]}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FormatType->TraditionalForm,
  FrameTicks->None,
  ImagePadding->15,
  ImageSize->{
   575.4849379623021, 
    Automatic}]],ExpressionUUID->"818c1af6-093a-4dbe-b919-e96d109d0ded"]], \
"Text",
 CellChangeTimes->{
  3.875194684219226*^9},ExpressionUUID->"08358723-21b9-435d-82c5-\
1021e74af3c1"],

Cell["Shenghui Yang, Wolfram Research", "Author",
 CellChangeTimes->{{3.8728561693882937`*^9, 
  3.8728561770538836`*^9}},ExpressionUUID->"648d7a87-4e96-454b-a6b0-\
36a8a79872ef"],

Cell["Ref.  Stanley, Enumerative Combinatorics P 23-24", "Text",
 CellChangeTimes->{{3.875193233302224*^9, 3.8751932367952795`*^9}, {
  3.8751934998505287`*^9, 3.875193500321618*^9}, {3.8751937123743987`*^9, 
  3.8751937268029795`*^9}, {3.87519386389774*^9, 3.875193866419587*^9}, {
  3.875203804866248*^9, 
  3.8752038173622103`*^9}},ExpressionUUID->"c3a7d4dd-b7a2-4ab0-976d-\
d2ca6f2857fb"],

Cell[BoxData[
 RowBox[{"(*", 
  RowBox[{
  "drops", " ", "the", " ", "least", " ", "item", " ", "in", " ", "the", " ", 
   "left", " ", "perm", " ", "after", " ", "generation"}], "*)"}]], "Input",
 CellChangeTimes->{{3.875193467022088*^9, 
  3.875193493268634*^9}},ExpressionUUID->"e54e2da3-c093-4b38-88cc-\
b8fcd40ce1a3"],

Cell["Here is one of the tree used in the text book.", "Text",
 CellChangeTimes->{{3.8751937419138117`*^9, 
  3.8751937555847445`*^9}},ExpressionUUID->"7a480993-4507-4126-8a14-\
0775fe974597"],

Cell[TextData[{
 "Pick the least item ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]],ExpressionUUID->
  "ad0bd59a-53b3-421f-8bad-7cdffec9503f"],
 " in the list and make it root (usually just 1 or 0 based on your starting \
point)"
}], "ItemNumbered",
 CellChangeTimes->{{3.875193819744956*^9, 3.875193852946702*^9}, {
  3.875193934334169*^9, 
  3.8751939361936293`*^9}},ExpressionUUID->"8c601125-df08-4a5a-9334-\
8b5f8667c1b6"],

Cell[TextData[{
 "Split the list by remove ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]],ExpressionUUID->
  "e470714a-238e-4169-94a4-33f3e6bd4aa5"]
}], "ItemNumbered",
 CellChangeTimes->{{3.875193819744956*^9, 3.875193851164287*^9}, {
  3.8751939167411776`*^9, 
  3.87519405371209*^9}},ExpressionUUID->"61b51d48-70d1-4ada-8bae-\
ba43ea13953f"],

Cell[TextData[{
 "Attach the subtrees of the left and right permutations to the root ",
 Cell[BoxData[
  FormBox["i", TraditionalForm]],ExpressionUUID->
  "7dd2cb06-877a-4a1b-a767-9ba8121f75b4"],
 ", again, by choosing the minimum value of the sublists as the root for \
subtrees."
}], "ItemNumbered",
 CellChangeTimes->{{3.875193819744956*^9, 3.875193851164287*^9}, {
  3.8751939167411776`*^9, 3.875194101282666*^9}, {3.875203382068325*^9, 
  3.8752034354837284`*^9}},ExpressionUUID->"cce77aad-3b7f-4302-9ec2-\
5843423c71e8"],

Cell["Do this repeatedly for the subtrees/sub-permutations", "ItemNumbered",
 CellChangeTimes->{{3.875193819744956*^9, 3.875193851164287*^9}, {
  3.8751939167411776`*^9, 
  3.8751941214241147`*^9}},ExpressionUUID->"9eb0ca03-daca-4d23-9734-\
4bf53a6cd677"],

Cell[CellGroupData[{

Cell["Define the operation recursively", "Section",
 CellChangeTimes->{{3.8751942492717133`*^9, 
  3.875194265053368*^9}},ExpressionUUID->"335b6107-3014-4d1c-88fd-\
34e1646d6dd0"],

Cell["\<\
The key to create demo efficiently is to use a proper data structure for the \
input. You want the output of reduced permutation in each step have the same \
structure:\
\>", "Text",
 CellChangeTimes->{{3.8751942778890486`*^9, 
  3.87519435183698*^9}},ExpressionUUID->"11e3c64d-d39f-4109-97c3-\
c89d95d38167"],

Cell["\<\
Instead of using plain list, we are benefited by using {left,right} structure \
to store the permutation table we use in each step\
\>", "Item",
 CellChangeTimes->{{3.8751943658968363`*^9, 
  3.8751944202068377`*^9}},ExpressionUUID->"8be4e82f-72b3-4312-b940-\
62ff0f514c9a"],

Cell[CellGroupData[{

Cell["Be careful with empty list and terminating conditions", "Item",
 CellChangeTimes->{{3.8751943658968363`*^9, 
  3.8751944324822206`*^9}},ExpressionUUID->"0399dc42-fc4f-4cac-850d-\
9bad9247c53e"],

Cell[BoxData[
 RowBox[{
  RowBox[{
   RowBox[{"splitPerm", "[", "perm_", "]"}], ":=", 
   RowBox[{
    RowBox[{
     RowBox[{"{", 
      RowBox[{
       RowBox[{"Most", "[", 
        RowBox[{"#", "[", 
         RowBox[{"[", "1", "]"}], "]"}], "]"}], ",", 
       RowBox[{"#", "[", 
        RowBox[{"[", "2", "]"}], "]"}]}], "}"}], "&"}], "@", 
    RowBox[{"With", "[", "\[IndentingNewLine]", 
     RowBox[{
      RowBox[{"{", 
       RowBox[{"split", "=", 
        RowBox[{
         InterpretationBox[
          TagBox[
           DynamicModuleBox[{Typeset`open = False}, 
            FrameBox[
             PaneSelectorBox[{False->GridBox[{
                {
                 PaneBox[GridBox[{
                    {
                    StyleBox[
                    StyleBox[
                    AdjustmentBox["\<\"[\[FilledSmallSquare]]\"\>",
                    BoxBaselineShift->-0.25,
                    BoxMargins->{{0, 0}, {-1, -1}}], "ResourceFunctionIcon",
                    
                    FontColor->RGBColor[
                    0.8745098039215686, 0.2784313725490196, 
                    0.03137254901960784]],
                    ShowStringCharacters->False,
                    FontFamily->"Source Sans Pro Black",
                    FontSize->0.6538461538461539 Inherited,
                    FontWeight->"Heavy",
                    PrivateFontOptions->{"OperatorSubstitution"->False}], 
                    StyleBox[
                    RowBox[{
                    StyleBox["SplitAt", "ResourceFunctionLabel"], " "}],
                    ShowAutoStyles->False,
                    ShowStringCharacters->False,
                    FontSize->Rational[12, 13] Inherited,
                    FontColor->GrayLevel[0.1]]}
                   },
                   GridBoxSpacings->{"Columns" -> {{0.25}}}],
                  Alignment->Left,
                  BaseStyle->{LineSpacing -> {0, 0}, LineBreakWithin -> False},
                  BaselinePosition->Baseline,
                  FrameMargins->{{3, 0}, {0, 0}}], 
                 ItemBox[
                  PaneBox[
                   TogglerBox[Dynamic[Typeset`open], {True->
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "FEBitmaps", "IconizeCloser"],
                    
                    ImageSizeCache->{
                    12.100000000000001`, {2., 10.100000000000001`}}], False->
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "FEBitmaps", "IconizeOpener"],
                    
                    ImageSizeCache->{
                    12.100000000000001`, {2., 10.100000000000001`}}]},
                    Appearance->None,
                    BaselinePosition->Baseline,
                    ContentPadding->False,
                    FrameMargins->0],
                   Alignment->Left,
                   BaselinePosition->Baseline,
                   FrameMargins->{{1, 1}, {0, 0}}],
                  Frame->{{
                    RGBColor[
                    0.8313725490196079, 0.8470588235294118, 
                    0.8509803921568627, 0.5], False}, {False, False}}]}
               },
               BaselinePosition->{1, 1},
               
               GridBoxAlignment->{
                "Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
               GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0}}}], True->
              GridBox[{
                {GridBox[{
                   {
                    PaneBox[GridBox[{
                    {
                    StyleBox[
                    StyleBox[
                    AdjustmentBox["\<\"[\[FilledSmallSquare]]\"\>",
                    BoxBaselineShift->-0.25,
                    BoxMargins->{{0, 0}, {-1, -1}}], "ResourceFunctionIcon",
                    
                    FontColor->RGBColor[
                    0.8745098039215686, 0.2784313725490196, 
                    0.03137254901960784]],
                    ShowStringCharacters->False,
                    FontFamily->"Source Sans Pro Black",
                    FontSize->0.6538461538461539 Inherited,
                    FontWeight->"Heavy",
                    PrivateFontOptions->{"OperatorSubstitution"->False}], 
                    StyleBox[
                    RowBox[{
                    StyleBox["SplitAt", "ResourceFunctionLabel"], " "}],
                    ShowAutoStyles->False,
                    ShowStringCharacters->False,
                    FontSize->Rational[12, 13] Inherited,
                    FontColor->GrayLevel[0.1]]}
                    },
                    GridBoxSpacings->{"Columns" -> {{0.25}}}],
                    Alignment->Left,
                    
                    BaseStyle->{
                    LineSpacing -> {0, 0}, LineBreakWithin -> False},
                    BaselinePosition->Baseline,
                    FrameMargins->{{3, 0}, {0, 0}}], 
                    ItemBox[
                    PaneBox[
                    TogglerBox[Dynamic[Typeset`open], {True->
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "FEBitmaps", "IconizeCloser"],
                    ImageSizeCache->{11., {2., 9.}}], False->
                    
                    DynamicBox[FEPrivate`FrontEndResource[
                    "FEBitmaps", "IconizeOpener"],
                    ImageSizeCache->{11., {2., 9.}}]},
                    Appearance->None,
                    BaselinePosition->Baseline,
                    ContentPadding->False,
                    FrameMargins->0],
                    Alignment->Left,
                    BaselinePosition->Baseline,
                    FrameMargins->{{1, 1}, {0, 0}}],
                    Frame->{{
                    RGBColor[
                    0.8313725490196079, 0.8470588235294118, 
                    0.8509803921568627, 0.5], False}, {False, False}}]}
                  },
                  BaselinePosition->{1, 1},
                  
                  GridBoxAlignment->{
                   "Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
                  
                  GridBoxItemSize->{
                   "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}},
                  GridBoxSpacings->{"Columns" -> {{0}}, "Rows" -> {{0}}}]},
                {
                 StyleBox[
                  PaneBox[GridBox[{
                    {
                    RowBox[{
                    TagBox["\<\"Version (latest): \"\>",
                    "IconizedLabel"], " ", 
                    TagBox["\<\"1.0.0\"\>",
                    "IconizedItem"]}]},
                    {
                    TagBox[
                    
                    TemplateBox[{
                    "\"Documentation \[RightGuillemet]\"", 
                    "https://resources.wolframcloud.com/FunctionRepository/\
resources/9be442a2-18f9-4417-ad47-5aa232215561/"},
                    "HyperlinkURL"],
                    "IconizedItem"]}
                    },
                    DefaultBaseStyle->"Column",
                    GridBoxAlignment->{"Columns" -> {{Left}}},
                    
                    GridBoxItemSize->{
                    "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}],
                   Alignment->Left,
                   BaselinePosition->Baseline,
                   FrameMargins->{{5, 4}, {0, 4}}], "DialogStyle",
                  FontFamily->"Roboto",
                  FontSize->11]}
               },
               BaselinePosition->{1, 1},
               
               GridBoxAlignment->{
                "Columns" -> {{Left}}, "Rows" -> {{Baseline}}},
               GridBoxDividers->{"Columns" -> {{None}}, "Rows" -> {False, {
                    GrayLevel[0.8]}, False}},
               
               GridBoxItemSize->{
                "Columns" -> {{Automatic}}, "Rows" -> {{Automatic}}}]}, 
              Dynamic[Typeset`open],
              BaselinePosition->Baseline,
              ImageSize->Automatic],
             
             Background->RGBColor[
              0.9686274509803922, 0.9764705882352941, 0.984313725490196],
             BaselinePosition->Baseline,
             DefaultBaseStyle->{},
             FrameMargins->{{0, 0}, {1, 0}},
             
             FrameStyle->RGBColor[
              0.8313725490196079, 0.8470588235294118, 0.8509803921568627],
             RoundingRadius->4]],
           {"FunctionResourceBox", 
            RGBColor[
            0.8745098039215686, 0.2784313725490196, 0.03137254901960784], 
            "SplitAt"},
           TagBoxNote->"FunctionResourceBox"],
          ResourceFunction[
           
           ResourceObject[<|
            "Name" -> "SplitAt", "ShortName" -> "SplitAt", "UUID" -> 
             "9be442a2-18f9-4417-ad47-5aa232215561", "ResourceType" -> 
             "Function", "Version" -> "1.0.0", "Description" -> 
             "Split a list before or after elements that satisfy a condition",
              "RepositoryLocation" -> 
             URL["https://www.wolframcloud.com/obj/resourcesystem/api/1.0"], 
             "SymbolName" -> 
             "FunctionRepository`$b0e36dcf296c44d8b00477ebc4862afa`SplitAt", 
             "FunctionLocation" -> 
             CloudObject[
              "https://www.wolframcloud.com/obj/46d52067-b74e-4e97-ba80-\
ba8b994aef2b"]|>, ResourceSystemBase -> Automatic]],
          Selectable->False], "[", 
         RowBox[{"perm", ",", 
          RowBox[{
           RowBox[{"(", 
            RowBox[{"#", "==", 
             RowBox[{"Min", "[", "perm", "]"}]}], ")"}], "&"}], ",", 
          "After"}], "]"}]}], "}"}], ",", "\[IndentingNewLine]", 
      RowBox[{"If", "[", 
       RowBox[{
        RowBox[{
         RowBox[{"Length", "[", "split", "]"}], "==", "1"}], ",", 
        RowBox[{"{", 
         RowBox[{
          RowBox[{"split", "[", 
           RowBox[{"[", "1", "]"}], "]"}], ",", 
          RowBox[{"{", "}"}]}], "}"}], ",", "split"}], "]"}]}], "]"}]}]}], 
  ";"}]], "Input",
 CellChangeTimes->{{3.875190820943932*^9, 3.875190865443337*^9}, {
   3.875191862849925*^9, 3.875191944191741*^9}, {3.875193091752767*^9, 
   3.875193092935846*^9}, 3.875193450797834*^9},
 CellLabel->"In[22]:=",ExpressionUUID->"2bd1a1fc-de47-4187-bf67-1c8c957f37ab"]
}, Open  ]],

Cell["\<\
Define tree recursively. The right side and left side are almost the same. \
Treat length one list separately:\
\>", "Text",
 CellChangeTimes->{{3.875194437808732*^9, 3.8751944443376904`*^9}, {
  3.8751944915172267`*^9, 
  3.8751945298434277`*^9}},ExpressionUUID->"5a3c6f20-ce5c-4ad3-bb57-\
22be93d74929"],

Cell[BoxData[
 RowBox[{"Clear", "[", "insert2", "]"}]], "Input",
 CellChangeTimes->{{3.875192672986308*^9, 3.8751926784086056`*^9}},
 CellLabel->"In[23]:=",ExpressionUUID->"b1b1ea21-a184-4ad1-aab2-94555eba9035"],

Cell[BoxData[
 RowBox[{
  RowBox[{"insert2", "[", 
   RowBox[{"node_", ",", 
    RowBox[{"{", 
     RowBox[{"perml_", ",", "permr_"}], "}"}]}], "]"}], ":=", 
  "\[IndentingNewLine]", 
  RowBox[{"If", "[", "\[IndentingNewLine]", 
   RowBox[{
    RowBox[{"perml", "===", "permr", "===", 
     RowBox[{"{", "}"}]}], ",", "node", ",", "\[IndentingNewLine]", 
    RowBox[{
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "perml", "]"}], "==", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"node", "[", 
        RowBox[{"\"\<SetLeft\>\"", ",", 
         RowBox[{"CreateDataStructure", "[", 
          RowBox[{"\"\<BinaryTree\>\"", ",", 
           RowBox[{"perml", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Length", "[", "perml", "]"}], ">=", "2"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"node", "[", 
         RowBox[{"\"\<SetLeft\>\"", ",", 
          RowBox[{"CreateDataStructure", "[", 
           RowBox[{"\"\<BinaryTree\>\"", ",", 
            RowBox[{"perml", "//", "Min"}]}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"insert2", "[", 
         RowBox[{
          RowBox[{"node", "[", "\"\<Left\>\"", "]"}], ",", 
          RowBox[{"splitPerm", "[", "perml", "]"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}], ";", "\[IndentingNewLine]", 
     RowBox[{"Which", "[", "\[IndentingNewLine]", 
      RowBox[{
       RowBox[{
        RowBox[{"Length", "[", "permr", "]"}], "==", "1"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{"node", "[", 
        RowBox[{"\"\<SetRight\>\"", ",", 
         RowBox[{"CreateDataStructure", "[", 
          RowBox[{"\"\<BinaryTree\>\"", ",", 
           RowBox[{"permr", "[", 
            RowBox[{"[", "1", "]"}], "]"}]}], "]"}]}], "]"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"Length", "[", "permr", "]"}], ">=", "2"}], ",", 
       "\[IndentingNewLine]", 
       RowBox[{
        RowBox[{"node", "[", 
         RowBox[{"\"\<SetRight\>\"", ",", 
          RowBox[{"CreateDataStructure", "[", 
           RowBox[{"\"\<BinaryTree\>\"", ",", 
            RowBox[{"permr", "//", "Min"}]}], "]"}]}], "]"}], ";", 
        "\[IndentingNewLine]", 
        RowBox[{"insert2", "[", 
         RowBox[{
          RowBox[{"node", "[", "\"\<Right\>\"", "]"}], ",", 
          RowBox[{"splitPerm", "[", "permr", "]"}]}], "]"}]}]}], 
      "\[IndentingNewLine]", "]"}]}]}], "\[IndentingNewLine]", 
   "]"}]}]], "Input",
 CellChangeTimes->{{3.8751880459387674`*^9, 3.8751880478388824`*^9}, {
   3.8751881312321863`*^9, 3.875188230724988*^9}, {3.8751883089472914`*^9, 
   3.8751883204765196`*^9}, {3.8751883870228443`*^9, 3.875188410173848*^9}, {
   3.8751884554378796`*^9, 3.8751884829075274`*^9}, {3.875188520950436*^9, 
   3.875188522865917*^9}, {3.875189015969963*^9, 3.875189061663971*^9}, {
   3.8751891141654367`*^9, 3.8751892739179134`*^9}, {3.875189407563389*^9, 
   3.87518951265802*^9}, {3.8751895609188967`*^9, 3.8751896429857807`*^9}, {
   3.8751904864396887`*^9, 3.8751905475939536`*^9}, {3.875190696485382*^9, 
   3.8751906970466375`*^9}, {3.8751909089219985`*^9, 
   3.8751909738944664`*^9}, {3.8751910069793434`*^9, 
   3.8751910892652664`*^9}, {3.8751911242827234`*^9, 
   3.8751911637795954`*^9}, {3.8751917293244195`*^9, 
   3.8751917610058374`*^9}, {3.8751917925744085`*^9, 
   3.8751917931170206`*^9}, {3.8751919734319315`*^9, 
   3.8751920417308235`*^9}, {3.875192074540756*^9, 3.875192128029529*^9}, {
   3.8751922317578344`*^9, 3.875192297912294*^9}, {3.875192331966504*^9, 
   3.8751924191073847`*^9}, {3.875192464074636*^9, 3.875192465995041*^9}, {
   3.8751925825774846`*^9, 3.875192601416561*^9}, {3.8751926916859655`*^9, 
   3.875192754978586*^9}, 3.875192790585374*^9, {3.8751928836249304`*^9, 
   3.87519288725854*^9}, {3.8751931532668285`*^9, 3.8751931656223326`*^9}, {
   3.875193458413216*^9, 3.875193462223449*^9}},
 CellLabel->"In[42]:=",ExpressionUUID->"1d224cf7-9063-4522-869f-fea1983f0775"],

Cell[BoxData[
 RowBox[{
  RowBox[{"ds", "=", 
   RowBox[{"CreateDataStructure", "[", 
    RowBox[{"\"\<BinaryTree\>\"", ",", "1"}], "]"}]}], ";"}]], "Input",
 CellChangeTimes->{{3.875141040551449*^9, 3.8751410533152657`*^9}, 
   3.8751845508527517`*^9, {3.875184580928939*^9, 3.875184581025417*^9}},
 CellLabel->"In[43]:=",ExpressionUUID->"0cc4f9a0-a561-4d2c-a40d-630bb27a7bed"],

Cell[BoxData[
 RowBox[{"insert2", "[", 
  RowBox[{"ds", ",", 
   RowBox[{"splitPerm", "[", 
    RowBox[{"{", 
     RowBox[{
     "5", ",", "7", ",", "3", ",", "1", ",", "6", ",", "2", ",", "8", ",", 
      "4"}], "}"}], "]"}]}], "]"}]], "Input",
 CellChangeTimes->{{3.8751845596858172`*^9, 3.8751845861368012`*^9}, {
  3.875184808775649*^9, 3.8751848115169*^9}, {3.8751849409507923`*^9, 
  3.875184944044657*^9}, {3.8751851384181337`*^9, 3.8751851419542*^9}, {
  3.8751858752164497`*^9, 3.8751858768895807`*^9}, {3.875186063863413*^9, 
  3.8751860965695825`*^9}, {3.8751864612333717`*^9, 3.8751864884246454`*^9}, {
  3.875192185707755*^9, 3.8751922001765614`*^9}, {3.875192842909856*^9, 
  3.8751928509808855`*^9}, {3.875193516657999*^9, 3.875193534982986*^9}},
 CellLabel->"In[44]:=",ExpressionUUID->"d8cb428d-615b-45fa-9490-a55a9409acc4"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"ds", "[", "\"\<Visualization\>\"", "]"}]], "Input",
 CellChangeTimes->{{3.8751927158899345`*^9, 3.8751927219848213`*^9}},
 CellLabel->"In[45]:=",ExpressionUUID->"1b7aa1b7-850b-4c87-8f68-1268024634fb"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11}, {
      Null, {{3, 4}, {3, 5}, {2, 3}, {2, 6}, {9, 10}, {9, 11}, {7, 8}, {7, 
       9}, {1, 2}, {1, 7}}}, {
      GraphLayout -> {
        "LayeredEmbedding", "RootVertex" -> 1, "Orientation" -> Top}, 
       ImagePadding -> 15, 
       VertexShapeFunction -> {
        DataStructure`Visualization`RenderVertex[{
          4 -> Null, 5 -> 7, 3 -> 5, 6 -> Null, 2 -> 3, 8 -> 6, 10 -> 8, 11 -> 
           Null, 9 -> 4, 7 -> 2, 1 -> 1}, #, #2, 
          DataStructure`Source`BinaryTree`Loader`Private`vertOpts$58840]& }, 
       VertexStyle -> {
         GrayLevel[0]}}]]}, 
    TagBox[GraphicsGroupBox[{
       {Hue[0.6, 0.7, 0.5], Opacity[0.7], Arrowheads[0.], 
        ArrowBox[CompressedData["
1:eJxTTMoPSmVmYGDgAmImKF7o3fK+gfu3/U6LxZsXeLA4QPiv7RdBxdHlYTSq
PLr621D+awx5iP4vaPII9QxoAJd5MHl097iu3zTV4DmDA0w9urzuockXBVax
w+XR+TD1MPPR5SH2c8PlAbWgibw=
         "], 0.03290821123233907]}, 
       {GrayLevel[0], EdgeForm[{GrayLevel[0], Opacity[0.7]}], InsetBox[
         FrameBox[
          PaneBox["1",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.6903085094570331, 2.53546276418555}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["3",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0.8451542547285166, 1.6903085094570334}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["5",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0.4225771273642583, 0.8451542547285167}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[InsetBox["\[EmptyCircle]", {0., 0.}, Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["7",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0.8451542547285166, 0.}, Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {1.267731382092775, 0.8451542547285167}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["2",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.53546276418555, 1.6903085094570334}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["6",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.1128856368212916, 0.8451542547285167}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["4",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.958039891549808, 0.8451542547285167}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["8",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.53546276418555, 0.}, Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {3.3806170189140663, 0.}, Center, 
          Automatic,
          Background->GrayLevel[1]],
         "InsetString"]}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FormatType->TraditionalForm,
  FrameTicks->None,
  ImagePadding->15,
  ImageSize->{277.2727272727293, Automatic}]], "Output",
 CellChangeTimes->{
  3.8751927223827286`*^9, 3.8751927675318456`*^9, {3.8751928477855005`*^9, 
   3.8751928540114684`*^9}, 3.8751929031862283`*^9, 3.8751931014992404`*^9, {
   3.87519315976655*^9, 3.8751931779195013`*^9}, 3.875193545498234*^9, 
   3.875198761233739*^9, 3.875198797904235*^9},
 CellLabel->"Out[45]=",ExpressionUUID->"12e522bf-22fb-44a6-be67-82b9c86def50"]
}, Open  ]],

Cell["Try larger model:", "Text",
 CellChangeTimes->{{3.875194453543017*^9, 
  3.87519447150246*^9}},ExpressionUUID->"a5da5576-5003-4b4c-aae5-\
e8ee98019db7"],

Cell[CellGroupData[{

Cell[BoxData[
 RowBox[{"perm2", "=", 
  RowBox[{"BlockRandom", "[", 
   RowBox[{
    RowBox[{"RandomChoice", "[", 
     RowBox[{
      RowBox[{"Range", "@", "100"}], ",", "100"}], "]"}], ",", 
    RowBox[{"RandomSeeding", "\[Rule]", "1234"}]}], "]"}]}]], "Input",
 CellChangeTimes->{{3.875193297137565*^9, 3.8751933264805245`*^9}, {
  3.875193406369722*^9, 3.875193411420762*^9}, {3.8751935725685186`*^9, 
  3.8751935920770397`*^9}, {3.875198603312439*^9, 3.87519864294783*^9}, {
  3.8751993564270515`*^9, 3.875199410894408*^9}, {3.8752037523401346`*^9, 
  3.8752037669000835`*^9}},
 CellLabel->"In[63]:=",ExpressionUUID->"af4e14a8-57d0-45c1-92d8-55b7cf27a05c"],

Cell[BoxData[
 RowBox[{"{", 
  RowBox[{
  "27", ",", "46", ",", "33", ",", "57", ",", "3", ",", "9", ",", "73", ",", 
   "45", ",", "39", ",", "23", ",", "13", ",", "23", ",", "10", ",", "48", 
   ",", "34", ",", "87", ",", "14", ",", "77", ",", "12", ",", "30", ",", "7",
    ",", "52", ",", "61", ",", "6", ",", "18", ",", "98", ",", "3", ",", "67",
    ",", "99", ",", "60", ",", "45", ",", "22", ",", "6", ",", "89", ",", 
   "53", ",", "45", ",", "37", ",", "94", ",", "67", ",", "19", ",", "89", 
   ",", "62", ",", "46", ",", "48", ",", "48", ",", "69", ",", "20", ",", 
   "61", ",", "54", ",", "48", ",", "67", ",", "69", ",", "35", ",", "50", 
   ",", "12", ",", "83", ",", "64", ",", "67", ",", "69", ",", "2", ",", "15",
    ",", "62", ",", "21", ",", "17", ",", "35", ",", "57", ",", "92", ",", 
   "19", ",", "30", ",", "49", ",", "35", ",", "52", ",", "75", ",", "43", 
   ",", "8", ",", "10", ",", "29", ",", "47", ",", "90", ",", "12", ",", "75",
    ",", "94", ",", "24", ",", "64", ",", "85", ",", "12", ",", "85", ",", 
   "29", ",", "79", ",", "90", ",", "56", ",", "74", ",", "38", ",", "53", 
   ",", "19", ",", "1", ",", "74", ",", "14", ",", "73", ",", "4"}], 
  "}"}]], "Output",
 CellChangeTimes->{
  3.87519332686063*^9, 3.875193412333294*^9, {3.8751935932759376`*^9, 
   3.875193595362295*^9}, 3.875198610106449*^9, 3.8751986437838116`*^9, 
   3.875198685807472*^9, {3.8751993595326996`*^9, 3.8751994113042536`*^9}, {
   3.875203755428007*^9, 3.875203768058025*^9}},
 CellLabel->"Out[63]=",ExpressionUUID->"acfc54aa-3f73-4387-8f5c-5bd1315f0adc"]
}, Open  ]],

Cell["Use the same code:", "Text",
 CellChangeTimes->{{3.8751944756513433`*^9, 
  3.875194480788159*^9}},ExpressionUUID->"5c2bed12-6e67-4de8-af4d-\
74f68f7dc36a"],

Cell[CellGroupData[{

Cell[BoxData[{
 RowBox[{
  RowBox[{"ds2", "=", 
   RowBox[{"CreateDataStructure", "[", 
    RowBox[{"\"\<BinaryTree\>\"", ",", "1"}], "]"}]}], ";"}], "\n", 
 RowBox[{
  RowBox[{"insert2", "[", 
   RowBox[{"ds2", ",", 
    RowBox[{"splitPerm", "[", "perm2", "]"}]}], "]"}], 
  ";"}], "\[IndentingNewLine]", 
 RowBox[{"ds2", "[", "\"\<Visualization\>\"", "]"}]}], "Input",
 CellChangeTimes->{{3.875193333873562*^9, 3.875193432644529*^9}, {
  3.875193608747979*^9, 3.8751936334459753`*^9}},
 CellLabel->"In[59]:=",ExpressionUUID->"538106bf-4a48-4de8-b4c7-0836938d7073"],

Cell[BoxData[
 GraphicsBox[
  NamespaceBox["NetworkGraphics",
   DynamicModuleBox[{Typeset`graph = HoldComplete[
     Graph[{1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14, 15, 16, 17, 18, 19,
       20, 21, 22, 23, 24, 25, 26, 27, 28, 29, 30, 31, 32, 33, 34, 35, 36, 37,
       38, 39, 40, 41, 42, 43, 44, 45, 46, 47, 48, 49, 50, 51, 52, 53, 54, 55,
       56, 57, 58, 59, 60, 61, 62, 63, 64, 65, 66, 67, 68, 69, 70, 71, 72, 73,
       74, 75, 76, 77, 78, 79, 80, 81}, {
      Null, {{6, 7}, {6, 8}, {4, 5}, {4, 6}, {18, 19}, {18, 20}, {17, 18}, {
       17, 21}, {16, 17}, {16, 22}, {15, 16}, {15, 23}, {26, 27}, {26, 28}, {
       25, 26}, {25, 29}, {24, 25}, {24, 30}, {14, 15}, {14, 24}, {12, 13}, {
       12, 14}, {31, 32}, {31, 33}, {11, 12}, {11, 31}, {34, 35}, {34, 36}, {
       10, 11}, {10, 34}, {9, 10}, {9, 37}, {3, 4}, {3, 9}, {42, 43}, {42, 
       44}, {48, 49}, {48, 50}, {46, 47}, {46, 48}, {56, 57}, {56, 58}, {55, 
       56}, {55, 59}, {53, 54}, {53, 55}, {51, 52}, {51, 53}, {45, 46}, {45, 
       51}, {41, 42}, {41, 45}, {39, 40}, {39, 41}, {65, 66}, {65, 67}, {63, 
       64}, {63, 65}, {70, 71}, {70, 72}, {73, 74}, {73, 75}, {69, 70}, {69, 
       73}, {68, 69}, {68, 76}, {62, 63}, {62, 68}, {60, 61}, {60, 62}, {38, 
       39}, {38, 60}, {2, 3}, {2, 38}, {78, 79}, {78, 80}, {77, 78}, {77, 
       81}, {1, 2}, {1, 77}}}, {
      GraphLayout -> {
        "LayeredEmbedding", "RootVertex" -> 1, "Orientation" -> Top}, 
       ImagePadding -> 15, 
       VertexShapeFunction -> {
        DataStructure`Visualization`RenderVertex[{
          5 -> Null, 7 -> 46, 8 -> 57, 6 -> 33, 4 -> 27, 13 -> Null, 19 -> 73,
            20 -> Null, 18 -> 45, 21 -> Null, 17 -> 39, 22 -> Null, 16 -> 23, 
           23 -> 23, 15 -> 13, 27 -> 48, 28 -> 87, 26 -> 34, 29 -> 77, 25 -> 
           14, 30 -> 30, 24 -> 12, 14 -> 10, 12 -> 9, 32 -> Null, 33 -> 61, 
           31 -> 52, 11 -> 7, 35 -> Null, 36 -> 98, 34 -> 18, 10 -> 6, 37 -> 
           Null, 9 -> 3, 3 -> 3, 40 -> Null, 43 -> 62, 44 -> Null, 42 -> 21, 
           47 -> Null, 49 -> Null, 50 -> 92, 48 -> 57, 46 -> 35, 52 -> Null, 
           54 -> 49, 57 -> Null, 58 -> 75, 56 -> 52, 59 -> Null, 55 -> 43, 53 -> 
           35, 51 -> 30, 45 -> 19, 41 -> 17, 39 -> 15, 61 -> Null, 64 -> Null,
            66 -> Null, 67 -> 90, 65 -> 47, 63 -> 29, 71 -> Null, 72 -> 94, 
           70 -> 75, 74 -> Null, 75 -> 85, 73 -> 64, 69 -> 24, 76 -> Null, 68 -> 
           12, 62 -> 12, 60 -> 10, 38 -> 8, 2 -> 2, 79 -> 74, 80 -> 73, 78 -> 
           14, 81 -> Null, 77 -> 4, 1 -> 1}, #, #2, 
          DataStructure`Source`BinaryTree`Loader`Private`vertOpts$60065]& }, 
       VertexStyle -> {
         GrayLevel[0]}}]]}, 
    TagBox[GraphicsGroupBox[{
       {Hue[0.6, 0.7, 0.5], Opacity[0.7], Arrowheads[0.], 
        ArrowBox[CompressedData["
1:eJx1lk1oE0EYhlfTpok2qLVNGjXS/OGpelGsFN0porl4aFSUikIRi/hTRaEt
KEgFwSoiCPEiBBHBoAfR+k+VIkIp1ByqVIQiqJWqh1BsexBsRNnN+y37phNY
hm+fd759Z+abmUQPntzZ4TEMo/X/s7D05IZG/Pl0RPVtnT717nFEjY/Ovjl8
pEZ9fzW8Odi8UjF/cWB0TTiSEM76uW317U+fGCrVdNO/73V9GX/e+2nvbM8q
4ay3v1Mw7/R3jWVTwTIe+vMo3vTXr8BZX9m449aX/ITptdrlGj4jnGPoD+Vi
ncndy8r4dsvHb+Hsp7vr8tTZC1UKeubPrPFXC2d9h5V3gUJ+5ra/gHDWwx90
zG0fXsnDeozXfu8r43ZbFM6xe748Gu5R4PPrCyb6MXf7KZrz6yfMilI/XT5w
1tvxe9Movdflc3NHb9BPl8/NnfnAern9Oty9fkWT9WjhV5fPPR5Hj/mFX10+
cK6nStc6+TT15lPu+nHq2T4nFit3vTn8+rfArlRoqbzn82RL+tjw2rt1st+Y
hz/mZvbfjgpn/Ymre+63Hq+V/cZ8SW3v1+rJoHCO0cIvc/s8CAtn/YajGy96
rtXI+Jh/mGofGFxUJ5zz9VjnRUjLMR/grMc4sT7MMY/gHEOPemUOP+Ds50fp
noCe+aXSPQTOMfTIz7zNW3Xlwa/VwjmGHnXPPGPVX4Nw1uP72C+6fOBcjw+7
s5OFiqisO/Pzm/qNty0x4RzDH9abeadV3wnhrIc/zDfzonUfNwjnGHrMN3M7
T1Q4+7HPj7jomY9Z9Z+k88bR2/snptz3jcPRH5z1eV/jmcx0VNabeXakJXN6
XVw454NfHbfPk6Rw/j+Vnhtace9cXPYN8+jg+Pq+gYRw1v+88TLQ/Dkm9aLL
B/4P/PRG6Q==
         "], 0.06846862903512453]}, 
       {GrayLevel[0], EdgeForm[{GrayLevel[0], Opacity[0.7]}], InsetBox[
         FrameBox[
          PaneBox["1",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.329883721411227, 7.426584034358605}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["2",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {4.602934896295177, 6.8077020314953876}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["3",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.0887267596633574, 6.188820028632171}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["27",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0.9283230042948256, 5.569938025768954}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {0.618882002863217, 4.951056022905737}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["33",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.237764005726434, 4.951056022905737}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["46",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0.9283230042948256, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["57",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.5472050071580425, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["3",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {3.2491305150318897, 5.569938025768954}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["6",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.939689513600281, 4.951056022905737}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["7",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.16608701002126, 4.332174020042519}, Center,
          Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["9",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.5472050071580425, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {1.237764005726434, 3.094410014316085}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["10",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.8566460085896512, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["13",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.237764005726434, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["23",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0.9283230042948256, 1.8566460085896512}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["39",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0.618882002863217, 1.2377640057264339}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["45",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0.3094410014316085, 0.6188820028632165}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["73",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {0., 0.}, Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {0.618882002863217, 0.}, Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], 
        TagBox[
         InsetBox["\[EmptyCircle]", {0.9283230042948256, 0.6188820028632165}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], 
        TagBox[
         InsetBox["\[EmptyCircle]", {1.237764005726434, 1.2377640057264339}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["23",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.5472050071580425, 1.8566460085896512}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["12",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.475528011452868, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["14",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.16608701002126, 1.8566460085896512}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["34",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.8566460085896512, 1.2377640057264339}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["48",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {1.5472050071580425, 0.6188820028632165}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["87",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.16608701002126, 0.6188820028632165}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["77",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.475528011452868, 1.2377640057264339}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["30",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.784969012884477, 1.8566460085896512}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["52",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {2.784969012884477, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {2.475528011452868, 3.094410014316085}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["61",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {3.094410014316085, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["18",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {3.7132920171793025, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {3.4038510157476938, 3.7132920171793025}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["98",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {4.022733018610912, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {3.558571516463498, 4.951056022905737}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["8",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.117143032926997, 6.188820028632171}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["15",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {5.41521752505315, 5.569938025768954}, Center,
          Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {5.105776523621541, 4.951056022905737}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["17",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {5.724658526484759, 4.951056022905737}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["21",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {4.951056022905737, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["62",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {4.641615021474128, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {5.2604970243373455, 3.7132920171793025}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["19",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {6.498261030063779, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["35",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {5.879379027200563, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {5.569938025768954, 3.094410014316085}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["57",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {6.188820028632171, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {5.879379027200563, 2.4755280114528686}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["92",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {6.498261030063779, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["30",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.117143032926997, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {6.807702031495388, 3.094410014316085}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["35",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.426584034358606, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["49",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.117143032926997, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["43",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.736025035790214, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["52",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.426584034358606, 1.8566460085896512}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {7.117143032926997, 1.2377640057264339}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["75",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {7.736025035790214, 1.2377640057264339}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {8.045466037221821, 1.8566460085896512}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["10",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {8.819068540800844, 5.569938025768954}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {8.509627539369236, 4.951056022905737}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["12",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {9.128509542232452, 4.951056022905737}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["29",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {8.045466037221821, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {7.736025035790214, 3.7132920171793025}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["47",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {8.354907038653431, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {8.045466037221821, 3.094410014316085}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["90",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {8.664348040085038, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["12",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {10.21155304724308, 4.332174020042519}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["24",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {9.902112045811473, 3.7132920171793025}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["75",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {9.283230042948256, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {8.973789041516648, 2.4755280114528686}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["94",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {9.592671044379864, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["64",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {10.52099404867469, 3.094410014316085}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {10.21155304724308, 2.4755280114528686}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["85",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {10.8304350501063, 2.4755280114528686}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {10.52099404867469, 3.7132920171793025}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"], InsetBox[
         FrameBox[
          PaneBox["4",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {10.056832546527277, 6.8077020314953876}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["14",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {9.747391545095669, 6.188820028632171}, 
         Center, Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["74",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {9.43795054366406, 5.569938025768954}, Center,
          Automatic,
         Background->GrayLevel[1]], InsetBox[
         FrameBox[
          PaneBox["73",
           Alignment->{Center, Center},
           ImageSize->{15},
           ImageSizeAction->"ShrinkToFit"],
          RoundingRadius->5,
          StripOnInput->False], {10.056832546527277, 5.569938025768954}, 
         Center, Automatic,
         Background->GrayLevel[1]], 
        TagBox[
         InsetBox["\[EmptyCircle]", {10.366273547958885, 6.188820028632171}, 
          Center, Automatic,
          Background->GrayLevel[1]],
         "InsetString"]}}],
     MouseAppearanceTag["NetworkGraphics"]],
    AllowKernelInitialization->False]],
  DefaultBaseStyle->{
   "NetworkGraphics", FrontEnd`GraphicsHighlightColor -> Hue[0.8, 1., 0.6]},
  FormatType->TraditionalForm,
  FrameTicks->None,
  ImagePadding->15,
  ImageSize->{615.3637258410917, Automatic}]], "Output",
 CellChangeTimes->{{3.875193630920605*^9, 3.875193633715475*^9}, {
  3.8751986299705534`*^9, 3.8751986463807073`*^9}, {3.8751986814578342`*^9, 
  3.8751986878935747`*^9}, {3.875199361517803*^9, 3.8751994131427155`*^9}},
 CellLabel->"Out[61]=",ExpressionUUID->"5a3d6ee5-341a-4e67-916e-3a884d2e92ef"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
},
WindowSize->{1270.6666666666667`, 648.},
WindowMargins->{{0, Automatic}, {Automatic, 0}},
Magnification:>1.1 Inherited,
FrontEndVersion->"13.1 for Microsoft Windows (64-bit) (August 22, 2022)",
StyleDefinitions->"Default.nb",
ExpressionUUID->"724f0f04-ee92-49be-a6d7-8c6abbb88c4e"
]
(* End of Notebook Content *)

(* Internal cache information *)
(*CellTagsOutline
CellTagsIndex->{}
*)
(*CellTagsIndex
CellTagsIndex->{}
*)
(*NotebookFileOutline
Notebook[{
Cell[CellGroupData[{
Cell[580, 22, 330, 5, 107, "Title",ExpressionUUID->"80257d39-3b61-4316-853a-55244f205f67"],
Cell[913, 29, 27916, 715, 467, "Text",ExpressionUUID->"08358723-21b9-435d-82c5-1021e74af3c1"],
Cell[28832, 746, 179, 3, 34, "Author",ExpressionUUID->"648d7a87-4e96-454b-a6b0-36a8a79872ef"],
Cell[29014, 751, 392, 6, 38, "Text",ExpressionUUID->"c3a7d4dd-b7a2-4ab0-976d-d2ca6f2857fb"],
Cell[29409, 759, 322, 7, 31, "Input",ExpressionUUID->"e54e2da3-c093-4b38-88cc-b8fcd40ce1a3"],
Cell[29734, 768, 192, 3, 38, "Text",ExpressionUUID->"7a480993-4507-4126-8a14-0775fe974597"],
Cell[29929, 773, 431, 11, 35, "ItemNumbered",ExpressionUUID->"8c601125-df08-4a5a-9334-8b5f8667c1b6"],
Cell[30363, 786, 348, 9, 35, "ItemNumbered",ExpressionUUID->"61b51d48-70d1-4ada-8bae-ba43ea13953f"],
Cell[30714, 797, 526, 11, 35, "ItemNumbered",ExpressionUUID->"cce77aad-3b7f-4302-9ec2-5843423c71e8"],
Cell[31243, 810, 255, 4, 35, "ItemNumbered",ExpressionUUID->"9eb0ca03-daca-4d23-9734-4bf53a6cd677"],
Cell[CellGroupData[{
Cell[31523, 818, 179, 3, 74, "Section",ExpressionUUID->"335b6107-3014-4d1c-88fd-34e1646d6dd0"],
Cell[31705, 823, 319, 7, 38, "Text",ExpressionUUID->"11e3c64d-d39f-4109-97c3-c89d95d38167"],
Cell[32027, 832, 284, 6, 35, "Item",ExpressionUUID->"8be4e82f-72b3-4312-b940-62ff0f514c9a"],
Cell[CellGroupData[{
Cell[32336, 842, 199, 3, 35, "Item",ExpressionUUID->"0399dc42-fc4f-4cac-850d-9bad9247c53e"],
Cell[32538, 847, 10425, 245, 101, "Input",ExpressionUUID->"2bd1a1fc-de47-4187-bf67-1c8c957f37ab"]
}, Open  ]],
Cell[42978, 1095, 315, 7, 38, "Text",ExpressionUUID->"5a3c6f20-ce5c-4ad3-bb57-22be93d74929"],
Cell[43296, 1104, 211, 3, 31, "Input",ExpressionUUID->"b1b1ea21-a184-4ad1-aab2-94555eba9035"],
Cell[43510, 1109, 4122, 88, 388, "Input",ExpressionUUID->"1d224cf7-9063-4522-869f-fea1983f0775"],
Cell[47635, 1199, 378, 7, 31, "Input",ExpressionUUID->"0cc4f9a0-a561-4d2c-a40d-630bb27a7bed"],
Cell[48016, 1208, 840, 15, 31, "Input",ExpressionUUID->"d8cb428d-615b-45fa-9490-a55a9409acc4"],
Cell[CellGroupData[{
Cell[48881, 1227, 224, 3, 31, "Input",ExpressionUUID->"1b7aa1b7-850b-4c87-8f68-1268024634fb"],
Cell[49108, 1232, 4886, 121, 257, "Output",ExpressionUUID->"12e522bf-22fb-44a6-be67-82b9c86def50"]
}, Open  ]],
Cell[54009, 1356, 158, 3, 38, "Text",ExpressionUUID->"a5da5576-5003-4b4c-aae5-e8ee98019db7"],
Cell[CellGroupData[{
Cell[54192, 1363, 661, 13, 31, "Input",ExpressionUUID->"af4e14a8-57d0-45c1-92d8-55b7cf27a05c"],
Cell[54856, 1378, 1574, 24, 78, "Output",ExpressionUUID->"acfc54aa-3f73-4387-8f5c-5bd1315f0adc"]
}, Open  ]],
Cell[56445, 1405, 162, 3, 38, "Text",ExpressionUUID->"5c2bed12-6e67-4de8-af4d-74f68f7dc36a"],
Cell[CellGroupData[{
Cell[56632, 1412, 566, 13, 73, "Input",ExpressionUUID->"538106bf-4a48-4de8-b4c7-0836938d7073"],
Cell[57201, 1427, 28033, 713, 500, "Output",ExpressionUUID->"5a3d6ee5-341a-4e67-916e-3a884d2e92ef"]
}, Open  ]]
}, Open  ]]
}, Open  ]]
}
]
*)

